#!/bin/sh
########################################################################
# TITLE    : setactiverel.sh
########################################################################
#
# Copyright 2015-2018 by Teradata Corporation. All Rights Reserved.
# TERADATA CONFIDENTIAL AND TRADE SECRET.
#
########################################################################
#
# PURPOSE  : Set the active version to this release
#
########################################################################
#
# History :
#                       DR
# Revision    Date      DCR    			DID      Comments
# ----------- --------- ------------ -------- ---------------------------
# 15.10.01.00 2016Jan25 CLNTINS-6093 SB186089 setactiverel.sh Needs To Create 
#                                             Softlinks in /usr/bin
# 15.10.01.00 2015Oct07 CLNTINS-5938 RM185040 Fix setactiverel.sh ...
# 15.10.01.00 2015May23 CLNTINS-5445 AW186011 Created.
# 16.00.00.00 2016Jan06 CLNTINS-6076 SB186089 Update setactiverel.sh script 
#                                             to no longer create the 
#                                             /usr/bin64/arcmain soft-link
# 16.00.00.00 2016Feb02 CLNTINS-6118 SB186089 setactiverel.sh Needs To Create 
#                                             Softlinks in /usr/lib for kafkaaxsmod.
# 16.00.00.00 2016Feb08 CLNTINS-6127 SB186089 create softlinks for Pre-Processor
#                                             applications for sqlpp and cobpp
# 15.10.01.00 2016May20 CLNTINS-6345 RM185040 ODBC_32 and ODBC_64 to switch in
#                                             sync with active release.
# 16.00.01.00 2016Nov14 CLNTINS-6867 RM185040 Do not create 32-bit symbolic
#                                             links for kafkaaxsmod.
# 16.00.02.00 2016Dec14 CLNTINS-7165 RM185040 Add S3 Access Module for 16.00.
# 16.00.02.00 2017Jan02 CLNTINS-7246 RM185040 Symbolic links for mqaxsmod
#                                             get removed when setactiverel.sh
#                                             is executed on zLinux.
# 16.00.03.00 2017Feb07 CLNTINS-7418 AW186011 Add rmSLinksLogin to remove softlinks
#                                             and updates to /etc/profile
# 16.10.00.00 2017Apr07 CLNTINS-7271 PP186048 Support for Ubuntu-${product}
# 16.20.00.00 2018Jan25 CLNTINS-8456 MS186163 Do not create /usr/lib soft links for ${product}. 
# 16.20.07.00 2018May12 CLNTINS-9677 AW186011 Update for the new 32-bit bteq package. 
# 16.20.08.00 2018May18 CLNTINS-9515 SB186089 Update SEN TDODBC to pick up the DD DM 8.0 files
# 16.20.11.00 2018May18 CLNTINS-8226 AW186011 Update to handle separate 32-bit bundle
# 17.00.06.00 2019JUL22 CLNTINS-11526 EA250023 Setactiverel.sh checking tdicu and tdwallet 
#                                               packages even if they're not installed. 
#
########################################################################
# this script does nothing if this is not being run on the system
# that installed the release
#install_pkg=`GET_INSTALLED_PKG`
TTU_PATH=DEST_INST_DIR
CURINSTVER=`basename $TTU_PATH`
CURINSTVER_NODOT=`echo $CURINSTVER | tr -d .`

pkgcmd="GET_INSTALLED_PKG"

USRLIB=OS_LIB_32
USRLIB64=OS_LIB_64
USRBIN=/usr/bin
USRBIN64=/usr/bin64

RemoveSoftLinks ()
{
  rm -fr $USRLIB/libicudatatd.${LIBEXT}          > /dev/null 2>&1
  rm -fr $USRLIB/libicudatatd.${LIBEXT}.${EXT2}  > /dev/null 2>&1
  rm -fr $USRLIB/libicui18ntd.${LIBEXT}          > /dev/null 2>&1
  rm -fr $USRLIB/libicui18ntd.${LIBEXT}.${EXT2}  > /dev/null 2>&1
  rm -fr $USRLIB/libicuiotd.${LIBEXT}            > /dev/null 2>&1
  rm -fr $USRLIB/libicuiotd.${LIBEXT}.${EXT2}    > /dev/null 2>&1
  rm -fr $USRLIB/libiculetd.${LIBEXT}            > /dev/null 2>&1
  rm -fr $USRLIB/libiculetd.${LIBEXT}.${EXT2}    > /dev/null 2>&1
  rm -fr $USRLIB/libiculxtd.${LIBEXT}            > /dev/null 2>&1
  rm -fr $USRLIB/libiculxtd.${LIBEXT}.${EXT2}    > /dev/null 2>&1
  rm -fr $USRLIB/libicuuctd.${LIBEXT}            > /dev/null 2>&1
  rm -fr $USRLIB/libicuuctd.${LIBEXT}.${EXT2}    > /dev/null 2>&1

  rm -f $USRLIB/libcliv2.${LIBEXT}           > /dev/null 2>&1
  rm -f $USRLIB/libtdusr.${LIBEXT}           > /dev/null 2>&1 

  rm -f $USRLIB/libppruntim.${LIBEXT}        > /dev/null 2>&1
  rm -f $USRLIB/libpm.${LIBEXT}              > /dev/null 2>&1

  rm -f  $USRLIB/libivicu27.${LIBEXT}          > /dev/null 2>&1
  rm -f  $USRLIB/libddicu27.${LIBEXT}          > /dev/null 2>&1
  rm -f  $USRLIB/libivicu28.${LIBEXT}          > /dev/null 2>&1
  rm -f  $USRLIB/libddicu28.${LIBEXT}          > /dev/null 2>&1
  rm -f  $USRLIB/libodbcinst.${LIBEXT}         > /dev/null 2>&1
  rm -f  $USRLIB/libodbc.${LIBEXT}             > /dev/null 2>&1
  rm -f  $USRLIB/odbccurs.${LIBEXT}            > /dev/null 2>&1
  rm -f  $USRLIB/vscnctdlg.${LIBEXT}           > /dev/null 2>&1
  
  rm -f  $USRLIB/libjmsam.${LIBEXT}            > /dev/null 2>&1
  rm -f  $USRLIB/libtelapi.${LIBEXT}           > /dev/null 2>&1

  rm -f $USRLIB/libmqs.${LIBEXT}               > /dev/null 2>&1
  rm -f $USRLIB/libmqsc.${LIBEXT}              > /dev/null 2>&1

  rm -f $USRLIB/np_axsmod.${LIBEXT}            > /dev/null 2>&1
  
  if [ $bitness = 64 ]; then
    rm -fr $USRLIB64/libicudatatd.${LIBEXT}         > /dev/null 2>&1
    rm -fr $USRLIB64/libicudatatd.${LIBEXT}.${EXT2} > /dev/null 2>&1
    rm -fr $USRLIB64/libicui18ntd.${LIBEXT}         > /dev/null 2>&1
    rm -fr $USRLIB64/libicui18ntd.${LIBEXT}.${EXT2} > /dev/null 2>&1
    rm -fr $USRLIB64/libicuiotd.${LIBEXT}           > /dev/null 2>&1
    rm -fr $USRLIB64/libicuiotd.${LIBEXT}.${EXT2}   > /dev/null 2>&1
    rm -fr $USRLIB64/libiculetd.${LIBEXT}           > /dev/null 2>&1
    rm -fr $USRLIB64/libiculetd.${LIBEXT}.${EXT2}   > /dev/null 2>&1
    rm -fr $USRLIB64/libiculxtd.${LIBEXT}           > /dev/null 2>&1
    rm -fr $USRLIB64/libiculxtd.${LIBEXT}.${EXT2}   > /dev/null 2>&1
    rm -fr $USRLIB64/libicuuctd.${LIBEXT}           > /dev/null 2>&1
    rm -fr $USRLIB64/libicuuctd.${LIBEXT}.${EXT2}   > /dev/null 2>&1
	
    rm -f $USRLIB64/libcliv2.${LIBEXT}           > /dev/null 2>&1
    rm -f $USRLIB64/libtdusr.${LIBEXT}           > /dev/null 2>&1 
	
    rm -f $USRLIB64/libppruntim.${LIBEXT}        > /dev/null 2>&1
    rm -f $USRLIB64/libpm.${LIBEXT}              > /dev/null 2>&1
	
    rm -f  $USRLIB64/libivicu27.${LIBEXT}        > /dev/null 2>&1
    rm -f  $USRLIB64/libddicu27.${LIBEXT}        > /dev/null 2>&1
    rm -f  $USRLIB64/libivicu28.${LIBEXT}        > /dev/null 2>&1
    rm -f  $USRLIB64/libddicu28.${LIBEXT}        > /dev/null 2>&1
    rm -f  $USRLIB64/libodbcinst.${LIBEXT}       > /dev/null 2>&1
    rm -f  $USRLIB64/libodbc.${LIBEXT}           > /dev/null 2>&1
    rm -f  $USRLIB64/odbccurs.${LIBEXT}          > /dev/null 2>&1
    rm -f  $USRLIB64/vscnctdlg.${LIBEXT}         > /dev/null 2>&1

    rm -f  $USRLIB64/libjmsam.${LIBEXT}          > /dev/null 2>&1
    rm -f  $USRLIB64/libtelapi.${LIBEXT}         > /dev/null 2>&1
 
    rm -f $USRLIB64/libmqs.${LIBEXT}             > /dev/null 2>&1
    rm -f $USRLIB64/libmqsc.${LIBEXT}            > /dev/null 2>&1

    rm -f $USRLIB64/np_axsmod.${LIBEXT}          > /dev/null 2>&1

    rm -f $USRLIB64/libs3axsmod.${LIBEXT}        > /dev/null 2>&1
    rm -f $USRLIB64/libazureaxsmod.${LIBEXT}     > /dev/null 2>&1
    rm -f $USRLIB64/libkafkaaxsmod.${LIBEXT}     > /dev/null 2>&1
  
  fi

  #remove the /usr/bin softlinks
  rm -f $USRBIN/bteq                           > /dev/null 2>&1
  rm -f $USRBIN/bteq32                         > /dev/null 2>&1
#  rm -f $USRBIN/tdwallet                       > /dev/null 2>&1
  rm -f $USRBIN/fastload                       > /dev/null 2>&1
  rm -f $USRBIN/mload                          > /dev/null 2>&1
  rm -f $USRBIN/fexp                           > /dev/null 2>&1
  rm -f $USRBIN/tpump                          > /dev/null 2>&1
  rm -f $USRBIN/tbuild                         > /dev/null 2>&1
  rm -f $USRBIN/tdload                         > /dev/null 2>&1
  rm -f $USRBIN/tdlog                          > /dev/null 2>&1
  rm -f $USRBIN/tlogview                       > /dev/null 2>&1
  rm -f $USRBIN/twbcmd                         > /dev/null 2>&1
  rm -f $USRBIN/twbertbl                       > /dev/null 2>&1
  rm -f $USRBIN/twbkill                        > /dev/null 2>&1
  rm -f $USRBIN/twbpath                        > /dev/null 2>&1
  rm -f $USRBIN/twbrmcp                        > /dev/null 2>&1
  rm -f $USRBIN/twbstat                        > /dev/null 2>&1
  rm -f $USRBIN/ppcmain                        > /dev/null 2>&1
  rm -f $USRBIN/ppbmain                        > /dev/null 2>&1
  # The following code was pre-15.10.04 where we were adding /usr/bin64/arcmain
  # so we remove it here if found
  if [ "$arch" = "Linux" ]  || [ "$arch" = "Ubuntu" ]
  then
    rm -f ${USRBIN64}/arcmain                    > /dev/null 2>&1
    rm -f $USRBIN/arcmain                        > /dev/null 2>&1
  fi
}

DeactiveCurrActiveRel ()
{
  product=$1

  #see if there is an active version
  if [ $arch = "Ubuntu" ]; then
	pkgs=`${pkgcmd}  ${product}${CURINSTVER_NODOT} 2> /dev/null | awk -F': ' '/^Package/{print $2}'`
  else
    pkgs=`${pkgcmd} | grep ${product} | egrep -v "(${product}13|${product}14|${product}1500|${product}${CURINSTVER_NODOT})"`
  fi

  if [ -n "$pkgs" ]
  then

    for ICUPKG in `echo $pkgs`
    do
      case $arch in
        ia64 | HP-UX)
          # hpux-ia and hpux-pa

          pkgindex="/var/adm/sw/products/${ICUPKG}/pfiles/INDEX"
          if [ -n "$pkgindex" ]
          then
            BASEDIR=`awk -F" " '$1 ~/^location/ {print $2 }' < ${pkgindex}`
            INSTVER=`awk -F" " '$1 ~/^revision/ {print $2 }' < ${pkgindex}`
          fi
          ;;

        Linux)
          # linux and zLinux
          BASEDIR=`rpm -q --queryformat '%{INSTPREFIXES}' ${ICUPKG}`
          INSTVER=`rpm -q --queryformat '%{version}' ${ICUPKG}`
          ;;

        SunOS)
          # the machine os on opeteron is SunOS so we can just use SunOS for both
          pkginfo="/var/sadm/pkg/${ICUPKG}/pkginfo"
          if [ -n "${pkginfo}" ]
          then
            BASEDIR=`awk -F= '$1 ~/^BASEDIR/ {print $2 }' < $pkginfo`
            INSTVER=`awk -F= '$1 ~/^VERSION/ { print $2 }' < ${pkginfo}`
          fi
          ;;
        Ubuntu)
          BASEDIR=`dpkg -L ${product}1610 | grep "/teradata/client" | head -1 |awk -F "/" '{print "/"$2}'`
          INSTVER=`dpkg -s ${product}1610 | awk -F': ' '/^Version/{print$2}'| awk -F- '{ print $1 }'`
          ;;

      esac

      if [ ${BASEDIR} = "/" ]
      then
        BASEDIR="/opt"
      fi

      # this is a valid pkg
      # ${product} exists at same or different prefix
      # find a version greater than 15.10.01
      if [ -n "$BASEDIR" ] && [ -n "$INSTVER" ]
      then
        ICUSHORTVER=`echo ${INSTVER} | sed 's#\([0-9][0-9]\).*\.\([0-9][0-9]\).*\.\([0-9][0-9]\).*\.\([0-9][0-9]\).*#\1.\2#'`
        ICUSHORTVER_NODOT=`echo ${INSTVER} | sed 's#\([0-9][0-9]\).*\.\([0-9][0-9]\).*\.\([0-9][0-9]\).*\.\([0-9][0-9]\).*#\1\2#'`

        usrFileYes=${BASEDIR}/teradata/client/${ICUSHORTVER}/ttu_softlinks_yes_${ICUSHORTVER_NODOT}
        usrFileNo=${BASEDIR}/teradata/client/${ICUSHORTVER}/ttu_softlinks_no_${ICUSHORTVER_NODOT}
        if [ -f $usrFileYes ] || [ -f $usrFileNo ]
        then
#          echo rename ${usrFileYes} to  ${usrFileYes}_notactive since not active after this script

          usrFileUpdate=${BASEDIR}/teradata/client/${ICUSHORTVER}/ttu_updateETC_${ICUSHORTVER_NODOT}
          mv $usrFileYes ${usrFileYes}_notactive           > /dev/null 2>&1
          mv $usrFileNo  ${usrFileNo}_notactive            > /dev/null 2>&1
          mv $usrFileUpdate ${usrFileUpdate}_notactive     > /dev/null 2>&1
        fi
      fi
    done
  fi
}

remove_env_path ()
{
  RMPKGPATH="$1"
  FILE="$2"
  
  TMP_FILE=${FILE}.tmp
  if [ -f "$FILE" ]; then
    pkginst_exists=`grep -i "$RMPKGPATH" "$FILE"`
  fi
  if [ -n "$pkginst_exists" ]; then
    grep -i -v "$RMPKGPATH" < "$FILE" > "$TMP_FILE"
    cp "$TMP_FILE" "$FILE"
    rm -f "$TMP_FILE"
  fi
}

install_pkg=`${pkgcmd} | grep tdicu${CURINSTVER_NODOT}`
if [ -z "$install_pkg" ]
then
  echo   "In order to use this release please source the .env files."
  echo   " "
fi

arch=ARCH_STR
#echo $arch
#arch=`echo $arch | awk '{print tolower($0)}'`

PROFILE="/etc/profile"
if [ $arch = "SunOS" ]
then
  LOGIN="/etc/.login"
else
  LOGIN="/etc/csh.login"
fi

#Bitness calculation
 case $arch in
    ia64 | HP-UX)
      bitness=`/usr/bin/getconf KERNEL_BITS`
      ;;

    Linux)
      bitness=`/usr/bin/getconf LONG_BIT`
      PROFILE="/etc/profile.d/td-ttu.sh"
      LOGIN="/etc/profile.d/td-ttu.csh"
      ;;

    SunOS)
      bitness=`/usr/bin/isainfo -b`
      ;;
    Ubuntu)
      bitness=`/usr/bin/getconf LONG_BIT`
      PROFILE="/etc/profile.d/td-ttu.sh"    # Login file for Bourne/Korn shell users
      LOGIN="/etc/profile.d/td-ttu.csh"     # Login file for C-shell users
      ;;

esac

if [ $arch = "HP-UX" ]
then
  LIBEXT=sl
else
  LIBEXT=so
fi

if [ -z "$1" ]
then
  #see if there is an active version
  DeactiveCurrActiveRel tdicu
  DeactiveCurrActiveRel tdwallet
fi

EXT1=52.1
EXT2=52

#CURINSTVER=`echo $TTU_PATH | rev | cut -d/ -f1 | rev`
CLIENTDIR=`dirname ${TTU_PATH}`
includepath=${TTU_PATH}/include
binPath=${TTU_PATH}/bin
libpath64=${TTU_PATH}/lib64
libpath=${TTU_PATH}/lib

envProfile=$CLIENTDIR/etc/ttu_bash.env
envLogin=$CLIENTDIR/etc/ttu_csh.env

usrfileyes=${TTU_PATH}/ttu_softlinks_yes_${CURINSTVER_NODOT}
usrfileno=${TTU_PATH}/ttu_softlinks_no_${CURINSTVER_NODOT}
usrfileupdate=${TTU_PATH}/ttu_updateETC_${CURINSTVER_NODOT}

# if $1 is rmSLinksLogin then change usrfileyes to usrfileno and then remove# softlinks
# and remove entry from /etc/profile
if [ "$1" = "rmSLinksLogin" ] && [ -f "$usrfileyes" ]; then
  mv $usrfileyes $usrfileno
  echo "Removing symbolic links from /usr/bin, /usr/lib and /usr/lib64"
  RemoveSoftLinks
  if [ -f "$usrfileupdate" ] && [ "$arch" != "Linux" ] && [ "$arch" != "Ubuntu" ]; then
    echo "Removing entries from /etc/profile and /etc/csh.login"
    remove_env_path ttu_csh.env $LOGIN
    remove_env_path ttu_bash.env $PROFILE
    rm $usrfileupdate
  fi
  
  exit 0
fi

if [ -f "${usrfileyes}_notactive" ]
then
  mv ${usrfileyes}_notactive $usrfileyes
fi
if [ -f "${usrfileno}_notactive" ]
then
  mv ${usrfileno}_notactive $usrfileno
fi
if [ -f "${usrfileupdate}_notactive" ]
then
  mv ${usrfileupdate}_notactive $usrfileupdate
fi

# set the .env softlink to this short versiom
ln -fs ${TTU_PATH}/etc/.ttupath_${CURINSTVER_NODOT}_bash.env $envProfile 
ln -fs ${TTU_PATH}/etc/.ttupath_${CURINSTVER_NODOT}_csh.env $envLogin
if [ -z "$1" ]
then
 echo "Changing active version to ${TTU_PATH}"
fi
#echo ${envProfile} is now ${TTU_PATH}/etc/.ttupath_${CURINSTVER_NODOT}_bash.env

if [ -f "$usrfileyes" ]
then
  RemoveSoftLinks
#ICU - no /usr/lib softlinks are created for ICU

# CLI
  if [ -f "${libpath}/libcliv2.${LIBEXT}" ]
  then
    ln -fs ${libpath}/libcliv2.${LIBEXT}         $USRLIB/libcliv2.${LIBEXT}
    ln -fs ${libpath}/libtdusr.${LIBEXT}         $USRLIB/libtdusr.${LIBEXT}
  fi
  if [ -f "${libpath64}/libcliv2.${LIBEXT}" ]
  then
    ln -fs ${libpath64}/libcliv2.${LIBEXT}       $USRLIB64/libcliv2.${LIBEXT}
    ln -fs ${libpath64}/libtdusr.${LIBEXT}       $USRLIB64/libtdusr.${LIBEXT}
  fi

# PP2
  if [ -f "${libpath}/libppruntim.${LIBEXT}" ]
  then
    ln -fs ${libpath}/libppruntim.${LIBEXT}     $USRLIB/libppruntim.${LIBEXT}
  fi
  if [ -f "${libpath64}/libppruntim.${LIBEXT}" ]
  then
    ln -fs ${libpath64}/libppruntim.${LIBEXT}     $USRLIB64/libppruntim.${LIBEXT}
  fi
 	
# PIOM
  if [ -f "${libpath}/libpm.${LIBEXT}" ]
  then
    ln -fs ${libpath}/libpm.${LIBEXT}            $USRLIB/libpm.${LIBEXT}
  fi
  if [ -f "${libpath64}/libpm.${LIBEXT}" ]
  then
    ln -fs ${libpath64}/libpm.${LIBEXT}            $USRLIB64/libpm.${LIBEXT}
  fi

# ODBC
  if [ -f "${libpath}/libodbc.${LIBEXT}" ]
  then
    if [ -f "${libpath}/libivicu28.${LIBEXT}" ]; then
     ln -fs ${libpath}/libivicu28.${LIBEXT}      $USRLIB/libivicu28.${LIBEXT}
    else 
     ln -fs ${libpath}/libivicu27.${LIBEXT}      $USRLIB/libivicu27.${LIBEXT}
    fi
    ln -fs ${libpath}/libodbcinst.${LIBEXT}     $USRLIB/libodbcinst.${LIBEXT}
    ln -fs ${libpath}/libodbc.${LIBEXT}         $USRLIB/libodbc.${LIBEXT}
    ln -fs ${libpath}/odbccurs.${LIBEXT}        $USRLIB/odbccurs.${LIBEXT}
    ln -fs ${libpath}/vscnctdlg.${LIBEXT}       $USRLIB/vscnctdlg.${LIBEXT}
  fi
  if [ -f "${libpath64}/libodbc.${LIBEXT}" ]
  then
    if [ -f "${libpath64}/libddicu28.${LIBEXT}" ]; then
       ln -fs ${libpath64}/libddicu28.${LIBEXT}      $USRLIB64/libddicu28.${LIBEXT}
    else
       ln -fs ${libpath64}/libddicu27.${LIBEXT}      $USRLIB64/libddicu27.${LIBEXT}
    fi
    ln -fs ${libpath64}/libodbcinst.${LIBEXT}     $USRLIB64/libodbcinst.${LIBEXT}
    ln -fs ${libpath64}/libodbc.${LIBEXT}         $USRLIB64/libodbc.${LIBEXT}
    ln -fs ${libpath64}/odbccurs.${LIBEXT}        $USRLIB64/odbccurs.${LIBEXT}
    ln -fs ${libpath64}/vscnctdlg.${LIBEXT}       $USRLIB64/vscnctdlg.${LIBEXT}
  fi

# Access Modules
#jmsaxsmod
  if [ -f "${libpath}/libjmsam.${LIBEXT}" ]
  then
    ln -fs ${libpath}/libjmsam.${LIBEXT}        $USRLIB/libjmsam.${LIBEXT}
  fi
  if [ -f "${libpath64}/libjmsam.${LIBEXT}" ]
  then
    ln -fs ${libpath64}/libjmsam.${LIBEXT}        $USRLIB64/libjmsam.${LIBEXT}
  fi
	
# mqaxsmod
  if [ -f "${libpath}/libmqs.${LIBEXT}" ]
  then
    ln -fs ${libpath}/libmqs.${LIBEXT}          $USRLIB/libmqs.${LIBEXT}
  fi
  if [ -f "${libpath}/libmqsc.${LIBEXT}" ]
  then
    ln -fs ${libpath}/libmqsc.${LIBEXT}         $USRLIB/libmqsc.${LIBEXT}
  fi
  if [ -f "${libpath64}/libmqs.${LIBEXT}" ]
  then
    ln -fs ${libpath64}/libmqs.${LIBEXT}          $USRLIB64/libmqs.${LIBEXT}
  fi
  if [ -f "${libpath64}/libmqsc.${LIBEXT}" ]
  then
    ln -fs ${libpath64}/libmqsc.${LIBEXT}         $USRLIB64/libmqsc.${LIBEXT}
  fi

# npipes
  if [ -f "${libpath}/np_axsmod.${LIBEXT}" ]
  then
    ln -fs ${libpath}/np_axsmod.${LIBEXT}        $USRLIB/np_axsmod.${LIBEXT}
  fi
  if [ -f "${libpath64}/np_axsmod.${LIBEXT}" ]
  then
    ln -fs ${libpath64}/np_axsmod.${LIBEXT}        $USRLIB64/np_axsmod.${LIBEXT}
  fi

# kafkaaxsmod
  if [ -f "${libpath64}/libkafkaaxsmod.${LIBEXT}" ]
  then
    ln -fs ${libpath64}/libkafkaaxsmod.${LIBEXT}        $USRLIB64/libkafkaaxsmod.${LIBEXT}
  fi

#s3axsmod
  if [ -f "${libpath64}/libs3axsmod.${LIBEXT}" ]
  then
    ln -fs ${libpath64}/libs3axsmod.${LIBEXT}        $USRLIB64/libs3axsmod.${LIBEXT}
  fi

#azureaxsmod
  if [ -f "${libpath64}/libazureaxsmod.${LIBEXT}" ]
  then
    ln -fs ${libpath64}/libazureaxsmod.${LIBEXT}        $USRLIB64/libazureaxsmod.${LIBEXT}
  fi

#tptbase
  if [ -f "${libpath}/libtelapi.${LIBEXT}" ]
  then
    ln -fs ${libpath}/libtelapi.${LIBEXT} $USRLIB/libtelapi.${LIBEXT}
  fi
  if [ -f "${libpath64}/libtelapi.${LIBEXT}" ]
  then
    ln -fs ${libpath64}/libtelapi.${LIBEXT} $USRLIB64/libtelapi.${LIBEXT}
  fi

  # create the /usr/bin softlinks
  if [ -f "${binPath}/bteq" ]
  then
    ln -fs ${binPath}/bteq $USRBIN/bteq
  fi
  if [ -f "${binPath}/bteq32" ]
  then
    ln -fs ${binPath}/bteq32 $USRBIN/bteq32
  fi
  if [ -f "${binPath}/tdwallet" ]
  then
    ln -fs ${binPath}/tdwallet $USRBIN/tdwallet
  fi
  if [ -f "${binPath}/fastload" ]
  then
    ln -fs ${binPath}/fastload $USRBIN/fastload
  fi
  if [ -f "${binPath}/mload" ]
  then
    ln -fs ${binPath}/mload $USRBIN/mload
  fi
  if [ -f "${binPath}/fexp" ]
  then
    ln -fs ${binPath}/fexp $USRBIN/fexp
  fi
  if [ -f "${binPath}/tpump" ]
  then
    ln -fs ${binPath}/tpump $USRBIN/tpump
  fi
  if [ -f "${binPath}/tptlaunch" ]
  then
    ln -fs ${binPath}/tptlaunch $USRBIN/tbuild
    ln -fs ${binPath}/tptlaunch $USRBIN/tdload
    ln -fs ${binPath}/tptlaunch $USRBIN/tlogview
    ln -fs ${binPath}/tptlaunch $USRBIN/twbcmd
    ln -fs ${binPath}/tptlaunch $USRBIN/twbertbl
    ln -fs ${binPath}/tptlaunch $USRBIN/twbkill
    ln -fs ${binPath}/tptlaunch $USRBIN/twbpath
    ln -fs ${binPath}/tptlaunch $USRBIN/twbrmcp
    ln -fs ${binPath}/tptlaunch $USRBIN/twbstat   
  fi
  if [ -f "${binPath}/tdlog" ]
  then
    ln -fs ${binPath}/tdlog $USRBIN/tdlog
  fi


#sqlpp
  if [ $bitness = 64 ]
  then
    if [ -f "${binPath}/ppcmain64" ]
    then
      ln -fs ${binPath}/ppcmain64 $USRBIN/ppcmain
    fi
  else
    if [ -f "${binPath}/ppcmain" ]
    then
      ln -fs ${binPath}/ppcmain $USRBIN/ppcmain
    fi
  fi
# cobpp
  if [ $bitness = 64 ]
  then
    if [ -f "${binPath}/ppbmain64" ]
    then
      ln -fs ${binPath}/ppbmain64 $USRBIN/ppbmain
    fi
  else
    if [ -f "${binPath}/ppbmain" ]
    then
      ln -fs ${binPath}/ppbmain $USRBIN/ppbmain
    fi
  fi


  # Create links for ODBC_32 and ODBC_64
  if [ -f "${libpath}/libodbc.${LIBEXT}" ]
  then
    rm -rf ${CLIENTDIR}/ODBC_32/lib
    rm -rf ${CLIENTDIR}/ODBC_32/include
    rm -rf ${CLIENTDIR}/ODBC_32/locale
    ln -fs ${libpath} ${CLIENTDIR}/ODBC_32/lib
    ln -fs ${includepath} ${CLIENTDIR}/ODBC_32/include
    if [ -d "${TTU_PATH}/odbc_32/locale" ]
    then
      ln -fs ${TTU_PATH}/odbc_32/locale ${CLIENTDIR}/ODBC_32/locale
    fi
  fi
  if [ -f "${libpath64}/libodbc.${LIBEXT}" ]
  then
    rm -rf ${CLIENTDIR}/ODBC_64/lib
    rm -rf ${CLIENTDIR}/ODBC_64/include
    rm -rf ${CLIENTDIR}/ODBC_64/locale
    ln -fs ${libpath64} ${CLIENTDIR}/ODBC_64/lib
    ln -fs ${includepath} ${CLIENTDIR}/ODBC_64/include
    if [ -d "${TTU_PATH}/odbc_64/locale" ]
    then
      ln -fs ${TTU_PATH}/odbc_64/locale ${CLIENTDIR}/ODBC_64/locale
    fi
  fi
fi


#Check for updating /etc/profile and /etc/csh.login files
if [ -f $usrfileupdate ]
then
  echo "Updating $LOGIN and $PROFILE..."

  remove_env_path ttu_csh.env $LOGIN
  remove_env_path ttu_bash.env $PROFILE

  if [ "$arch" = "Linux" ] ||  [ "$arch" = "Ubuntu" ]; then
    echo ". ${envProfile}"    > ${PROFILE}
    echo "source ${envLogin}" > ${LOGIN}
    remove_env_path ttu_bash.env "/etc/profile"
    remove_env_path ttu_csh.env  "/etc/csh.login"
  else
    remove_env_path ttu_csh.env $LOGIN
    remove_env_path ttu_bash.env $PROFILE
    echo ". ${envProfile}" >> ${PROFILE}
    echo "source ${envLogin}" >> ${LOGIN}
  fi
else
  echo "$LOGIN and $PROFILE will not be updated."
fi 

