#!/bin/sh
#***********************************************************************
#*    Copyright 2017 Teradata Corporation. ALL RIGHTS RESERVED.
#*    TERADATA CONFIDENTIAL AND TRADE SECRET.
#*
#*    Teradata Parallel Transporter Quick Start validatation for UNIX
#* History Information (using JIRA issue numbers)
#*
#* Revision    Date       Issue      DID      Comments
#* ----------- ---------- ---------- -------- ----------------------------------
#* Initial version
#*
#************************************************************************
REQUIRED_ARGS=0
error_handle (){
        echo "$@"
        echo "Note:"
        echo "***************************************************************************"
        echo "* Teradata Parallel Transporter installation validation failed.           *"
        echo "* Please refer to the console messages and try to fix the errors before   *"
        echo "* re-running the job again. If the job error message does not make sense, *"
        echo "* please capture the console output and send it to the Teradata GSC team. *"
        echo "***************************************************************************"
}

if test ! $# = $REQUIRED_ARGS
then
  echo "Usage: tptvalidate.sh"
  exit 1
fi
current_dir=`pwd`
base_dir=`dirname "$0"`
cd "$base_dir"
echo "*******************************************************************"
echo "* Teradata Parallel Transporter installation validation starting. *"
echo "*******************************************************************"
if [ -f "../tbuild/checkpoint/*" ];then
        rm -rf ../tbuild/checkpoint/*
fi
cd ../tbuild/sample/validate
tbuild -f tptvalidate.tpt 
if [ $? != 0 ]; then
        error_handle "TPT validation tptvalidate.tpt job script failed."
        exit 1
fi
cd "$current_dir"
echo "*********************************************************************"
echo "* Teradata Parallel Transporter installation validation succeeded!! *"
echo "*********************************************************************"

exit 0

