#!/bin/sh
#******************************************************************************
#*    Copyright 2017 Teradata Corporation. ALL RIGHTS RESERVED.
#*    TERADATA CONFIDENTIAL AND TRADE SECRET.
#*
#*    Teradata Azure Access Module Quick Start
#*    validatation for UNIX
#*
#*******************************************************************************
REQUIRED_ARGS=5
error_handle (){
        echo "$@"
        echo "Note:"
        echo "***************************************************************************"
        echo "* Please refer to the console messages and try to fix the errors before   *"
        echo "* re-running the job again. If the job error message does not make sense, *"
        echo "* please capture the console output and send it to the Teradata GSC team. *"
        echo "***************************************************************************"
}

if test ! $# = $REQUIRED_ARGS
then
  echo "Usage: ./azureaxsmod_validate.ksh <NODEID> <UserName> <UserPassword> <CONTAINERNAME>"
  echo "<OBJETNAME>" 
  echo "where   <NODEID> is a database name id"
  echo "        <UserName> is database User Name."
  echo "        <UserPassword> is database User Password."
  echo "        <CONTAINERNAME> is azure blob storage container name"
  echo "        <OBJETNAME> is azure blob object name"
  exit 1
fi

CURRDIR=`pwd`
cd ../quickstart
echo "started execution at `date`"
rm -rf tmp_quickstart
mkdir tmp_quickstart
cp azureaxsmod_qstart.tpt azureaxsmod_attr ./tmp_quickstart/
cd tmp_quickstart

sed -e "s/NODEID/$1/g" azureaxsmod_attr > azureaxsmod_attr_temp
mv azureaxsmod_attr_temp azureaxsmod_attr
sed -e "s/Uname/$2/g" azureaxsmod_attr > azureaxsmod_attr_temp
mv azureaxsmod_attr_temp azureaxsmod_attr
sed -e "s/Passwd/$3/g" azureaxsmod_attr > azureaxsmod_attr_temp
mv azureaxsmod_attr_temp azureaxsmod_attr

sed -e "s/CONTAINERNAME/$4/g" azureaxsmod_qstart.tpt > azureaxsmod_qstart.tpt_temp
mv azureaxsmod_qstart.tpt_temp azureaxsmod_qstart.tpt
sed -e "s/OBJETNAME/$5/g" azureaxsmod_qstart.tpt > azureaxsmod_qstart.tpt_temp
mv azureaxsmod_qstart.tpt_temp azureaxsmod_qstart.tpt

echo "executing azureaxsmod_qstart.tpt.."
tbuild -f azureaxsmod_qstart.tpt -v azureaxsmod_attr -j azureaxsmodjob

if [ $? != 0 ]; then
        error_handle "Quick Start azureaxsmod_qstart.tpt job script failed."
        cd ..
        rm -rf tmp_quickstart
        exit 1
fi

cd ..
rm -rf tmp_quickstart
echo "azureaxsmod Validation completed successfully."
cd $CURRDIR
exit 0
