#!/bin/sh
#***********************************************************************
#*    Copyright 2014 Teradata Corporation. ALL RIGHTS RESERVED.
#*    TERADATA CONFIDENTIAL AND TRADE SECRET.
#*
#*    Teradata Java Message Service(JMS) Quick Start validatation for UNIX
#*
#************************************************************************
REQUIRED_ARGS=3
error_handle (){
        echo "$@"
        echo "Note:"
        echo "***************************************************************************"
        echo "* Please refer to the console messages and try to fix the errors before   *"
        echo "* re-running the job again. If the job error message does not make sense, *"
        echo "* please capture the console output and send it to the Teradata GSC team. *"
        echo "***************************************************************************"
}

if test ! $# = $REQUIRED_ARGS
then
  echo "Usage: ./jmsaxsmodvalidate.ksh <NODEID> <UserName> <UserPassword>"
  echo "where   <NODEID> is a database name id"
  echo "        <UserName> is database User Name."
  echo "        <UserPassword> is database User Password."
  exit 1
fi

USE_SL=0
uname -a | grep -i HP-UX > /dev/null
if [ $? -eq 0 ]
then
    uname -a | grep -i ia64 > /dev/null
    if [ $? -eq 1 ]
    then
        USE_SL=1
    fi
fi

CURRDIR=`pwd`
qscript=jmsaxsmodqstart.fl
cd ./../quickstart

echo "started execution at `date`"
sed -e "s/NODEID/$1/g" $qscript > ${qscript}_tmp
sed -e "s/UserName/$2/g" ${qscript}_tmp > ${qscript}_tmp1
sed -e "s/UserPassword/$3/g" ${qscript}_tmp1 > ${qscript}_tmp2
if [ $USE_SL -eq 1 ]
then
   sed -e "s/libjmsam.dll/libjmsam.sl/g" ${qscript}_tmp2 > ${qscript}_tmp3
else
   sed -e "s/libjmsam.dll/libjmsam.so/g" ${qscript}_tmp2 > ${qscript}_tmp3
fi
mv ${qscript}_tmp3 ${qscript}_tmp
echo "executing $qscript.."
fastload  <  ${qscript}_tmp


if [ $? != 0 ]; then
        error_handle "Quick Start $qscript  job script failed."
        rm -rf  ${qscript}_tmp
        rm -rf  ${qscript}_tmp1
        rm -rf  ${qscript}_tmp2
        exit 1
fi

rm -rf  ${qscript}_tmp
rm -rf  ${qscript}_tmp1
rm -rf  ${qscript}_tmp2

echo "jmsaxsmod Validation completed successfully."

cd $CURRDIR
exit 0

