#!/bin/sh
#******************************************************************************
#*    Copyright 2016 Teradata Corporation. ALL RIGHTS RESERVED.
#*    TERADATA CONFIDENTIAL AND TRADE SECRET.
#*
#*    Teradata Kafka Message Queue Access Module Quick Start
#*    validatation for UNIX
#*
#*******************************************************************************
REQUIRED_ARGS=6
error_handle (){
        echo "$@"
        echo "Note:"
        echo "***************************************************************************"
        echo "* Please refer to the console messages and try to fix the errors before   *"
        echo "* re-running the job again. If the job error message does not make sense, *"
        echo "* please capture the console output and send it to the Teradata GSC team. *"
        echo "***************************************************************************"
}

if test ! $# = $REQUIRED_ARGS
then
  echo "Usage: ./kafkaaxsmod_validate.ksh <NODEID> <UserName> <UserPassword> <TOPICNAME>"
  echo "<BROKER> <PARTITIONS>" 
  echo "where   <NODEID> is a database name id"
  echo "        <UserName> is database User Name."
  echo "        <UserPassword> is database User Password."
  echo "        <TOPICNAME> is a Kafka Message Server topic name"
  echo "        <BROKER> is a kafka Message Server Broker e.g. KAFKASERVERIPADDRESS:PORTNO"
  echo "        <PARTITIONS> is partitions of the topic e.g. 0,1"
  exit 1
fi

CURRDIR=`pwd`
cd ../quickstart
echo "started execution at `date`"
rm -rf tmp_quickstart
mkdir tmp_quickstart
cp kafkaaxsmod_qstart.tpt kafkaaxsmod_attr ./tmp_quickstart/
cd tmp_quickstart

sed -e "s/NODEID/$1/g" kafkaaxsmod_attr > kafkaaxsmod_attr_temp
mv kafkaaxsmod_attr_temp kafkaaxsmod_attr
sed -e "s/Uname/$2/g" kafkaaxsmod_attr > kafkaaxsmod_attr_temp
mv kafkaaxsmod_attr_temp kafkaaxsmod_attr
sed -e "s/Passwd/$3/g" kafkaaxsmod_attr > kafkaaxsmod_attr_temp
mv kafkaaxsmod_attr_temp kafkaaxsmod_attr

sed -e "s/TOPIC/$4/g" kafkaaxsmod_qstart.tpt > kafkaaxsmod_qstart.tpt_temp
mv kafkaaxsmod_qstart.tpt_temp kafkaaxsmod_qstart.tpt
sed -e "s/BROKER/$5/g" kafkaaxsmod_qstart.tpt > kafkaaxsmod_qstart.tpt_temp
mv kafkaaxsmod_qstart.tpt_temp kafkaaxsmod_qstart.tpt
sed -e "s/PARTITIONS/$6/g" kafkaaxsmod_qstart.tpt > kafkaaxsmod_qstart.tpt_temp
mv kafkaaxsmod_qstart.tpt_temp kafkaaxsmod_qstart.tpt

echo "executing kafkaaxsmod_qstart.tpt.."
tbuild -f kafkaaxsmod_qstart.tpt -v kafkaaxsmod_attr -j kafkaaxsmodjob

if [ $? != 0 ]; then
        error_handle "Quick Start kafkaaxsmod_qstart.tpt job script failed."
        cd ..
        rm -rf tmp_quickstart
        exit 1
fi

cd ..
rm -rf tmp_quickstart
echo "kafkaaxsmod Validation completed successfully."
cd $CURRDIR
exit 0
