#!/bin/sh
#***********************************************************************
#*    Copyright 2014 Teradata Corporation. ALL RIGHTS RESERVED.
#*    TERADATA CONFIDENTIAL AND TRADE SECRET.
#*
#*    Teradata MultiLoad Quick Start validation for UNIX
#*
#************************************************************************
REQUIRED_ARGS=3
error_handle (){
        echo "$@"
        echo "Note:"
        echo "***************************************************************************"
        echo "* Please refer to the console messages and try to fix the errors before   *"
        echo "* re-running the job again. If the job error message does not make sense, *"
        echo "* please capture the console output and send it to the Teradata GSC team. *"
        echo "***************************************************************************"
}

if test ! $# = $REQUIRED_ARGS
then
  echo "Usage: ./mloadvalidate.ksh <NODEID> <UserName> <UserPassword>"
  echo "where   <NODEID> is a database name id"
  echo "        <UserName> is database User Name."
  echo "        <UserPassword> is database User Password."
  exit 1
fi

CURRDIR=`pwd`
cd ./../quickstart
echo "started execution at `date`"
testname=mload_sample.ml
cp $testname ${testname}_tmp

sed -e "s/NODEID/$1/g" ${testname}_tmp > ${testname}_temp
mv ${testname}_temp ${testname}_tmp
sed -e "s/Username/$2/g" ${testname}_tmp > ${testname}_temp
mv ${testname}_temp ${testname}_tmp
sed -e "s/UserPassword/$3/g" ${testname}_tmp > ${testname}_temp
mv ${testname}_temp ${testname}_tmp

mload<${testname}_tmp
 
if [ $? != 0 ]; then
        error_handle "Quick Start MultiLoad job script failed."
        rm -rf ${testname}_tmp
        exit 1
fi

echo "MultiLoad Validation completed successfully."
rm -rf ${testname}_tmp

cd $CURRDIR
exit 0

