#!/bin/sh
#******************************************************************************
#*    Copyright 2014 Teradata Corporation. ALL RIGHTS RESERVED.
#*    TERADATA CONFIDENTIAL AND TRADE SECRET.
#*
#*    Teradata Message Queue Access Module Quick Start validatation for UNIX
#*
#*******************************************************************************
REQUIRED_ARGS=3
error_handle (){
        echo "$@"
        echo "Note:"
        echo "***************************************************************************"
        echo "* Please refer to the console messages and try to fix the errors before   *"
        echo "* re-running the job again. If the job error message does not make sense, *"
        echo "* please capture the console output and send it to the Teradata GSC team. *"
        echo "***************************************************************************"
}

if test ! $# = $REQUIRED_ARGS
then
  echo "Usage: ./mqaxsmodvalidate.ksh <NODEID> <UserName> <UserPassword>"
  echo "where   <NODEID> is a database name id"
  echo "        <UserName> is database User Name."
  echo "        <UserPassword> is database User Password."
  exit 1
fi

USE_SL=0
uname -a | grep -i HP-UX > /dev/null
if [ $? -eq 0 ]
then
    uname -a | grep -i ia64 > /dev/null
    if [ $? -eq 1 ]
    then
        USE_SL=1
    fi
fi

CURRDIR=`pwd`
cd ./../quickstart
echo "started execution at `date`"
rm -rf tmp_quickstart
mkdir tmp_quickstart
cp mqaxsmodqstart.fl ./tmp_quickstart/
cd tmp_quickstart

sed -e "s/NODEID/$1/g" mqaxsmodqstart.fl > mqaxsmodqstart.fl_temp
mv mqaxsmodqstart.fl_temp mqaxsmodqstart.fl
sed -e "s/UserName/$2/g" mqaxsmodqstart.fl > mqaxsmodqstart.fl_temp
mv mqaxsmodqstart.fl_temp mqaxsmodqstart.fl
sed -e "s/UserPassword/$3/g" mqaxsmodqstart.fl > mqaxsmodqstart.fl_temp
mv mqaxsmodqstart.fl_temp mqaxsmodqstart.fl
if [ $USE_SL -eq 1 ]
then
   sed -e "s/libmqs.dll/libmqs.sl/g" mqaxsmodqstart.fl > mqaxsmodqstart.fl_temp
else
   sed -e "s/libmqs.dll/libmqs.so/g" mqaxsmodqstart.fl > mqaxsmodqstart.fl_temp
fi
mv mqaxsmodqstart.fl_temp mqaxsmodqstart.fl

echo "executing mqaxsmodqstart.fl.."
fastload < mqaxsmodqstart.fl 

if [ $? != 0 ]; then
        error_handle "Quick Start mqaxsmodqstart.fl job script failed."
        cd ..
        rm -rf tmp_quickstart
        exit 1
fi

cd ..
rm -rf tmp_quickstart
echo "mqaxsmod Validation completed successfully."
cd $CURRDIR
exit 0

