#!/bin/sh
#***********************************************************************
#*    Copyright 2014 Teradata Corporation. ALL RIGHTS RESERVED.
#*    TERADATA CONFIDENTIAL AND TRADE SECRET.
#*
#*    Teradata Named Pipe Access Module Quick Start validatation for UNIX
#*
#************************************************************************
REQUIRED_ARGS=3
error_handle (){
        echo "$@"
        echo "Note:"
        echo "***************************************************************************"
        echo "* Please refer to the console messages and try to fix the errors before   *"
        echo "* re-running the job again. If the job error message does not make sense, *"
        echo "* please capture the console output and send it to the Teradata GSC team. *"
        echo "***************************************************************************"
}

if test ! $# = $REQUIRED_ARGS
then
  echo "Usage: ./npaxsmodvalidate.ksh <NODEID> <UserName> <UserPassword>"
  echo "where   <NODEID> is a database name id"
  echo "        <UserName> is database User Name."
  echo "        <UserPassword> is database User Password."
  exit 1
fi

CURRDIR=`pwd`
cd ./../quickstart
echo "started execution at `date`"


qscriptfl=npaxsmodqstart.fl
qscriptfe=npaxsmodqstart.fe

uname -a | grep -i HP-UX > /dev/null
if [ $? -eq 0 ]
then
    uname -a | grep -i ia64 > /dev/null
    if [ $? -eq 1 ]
    then
       sed -e "s/np_axsmod.so/np_axsmod.sl/g" $qscriptfl > ${qscriptfl}_tmp
       mv ${qscriptfl}_tmp $qscriptfl
    fi
fi

sed -e "s/NODEID/$1/g" $qscriptfl > ${qscriptfl}_tmp
sed -e "s/UserName/$2/g" ${qscriptfl}_tmp > ${qscriptfl}_tmp1
sed -e "s/UserPassword/$3/g" ${qscriptfl}_tmp1 > ${qscriptfl}_tmp2
mv ${qscriptfl}_tmp2 ${qscriptfl}_tmp

sed -e "s/NODEID/$1/g" $qscriptfe > ${qscriptfe}_tmp
sed -e "s/UserName/$2/g" ${qscriptfe}_tmp > ${qscriptfe}_tmp1
sed -e "s/UserPassword/$3/g" ${qscriptfe}_tmp1 > ${qscriptfe}_tmp2
mv ${qscriptfe}_tmp2 ${qscriptfe}_tmp

echo "executing $qscriptfl.."

fastload < ${qscriptfl}_tmp &
pidReader=$!
sleep 15;
if [ $? != 0 ]; then
        error_handle "Quick Start $qscript.fl job script failed."
        exit 1
fi

echo "executing $qscriptfe.."
fexp < ${qscriptfe}_tmp&
pidWriter=$!
 
if [ $? != 0 ]; then
        error_handle "Quick Start $qscript.fe job script failed."
        exit 1
fi


rm -rf ${qscriptfe}_tmp
rm -rf ${qscriptfe}_tmp1
rm -rf ${qscriptfl}_tmp
rm -rf ${qscriptfl}_tmp1

wait $pidReader
wait $pidWriter

echo "NPAXSMOD Validation completed successfully."
cd $CURRDIR
exit 0



