#!/bin/sh
#***********************************************************************
#*    Copyright 2014 Teradata Corporation. ALL RIGHTS RESERVED.
#*    TERADATA CONFIDENTIAL AND TRADE SECRET.
#*
#*    Teradata Data connector Quick Start validatation for UNIX
#*
#************************************************************************
REQUIRED_ARGS=3
error_handle (){
        echo "$@"
        echo "Note:"
        echo "***************************************************************************"
        echo "* Please refer to the console messages and try to fix the errors before   *"
        echo "* re-running the job again. If the job error message does not make sense, *"
        echo "* please capture the console output and send it to the Teradata GSC team. *"
        echo "***************************************************************************"
}

if test ! $# = $REQUIRED_ARGS
then
  echo "Usage: ./piomvalidate.ksh <NODEID> <UserName> <UserPassword>"
  echo "where   <NODEID> is a database name id"
  echo "        <UserName> is database User Name."
  echo "        <UserPassword> is database User Password."
  exit 1
fi

CURRDIR=`pwd`
qscript=piomqstart.fl
cd ./../quickstart

echo "started execution at `date`"
sed -e "s/NODEID/$1/g" $qscript > ${qscript}_tmp
sed -e "s/UserName/$2/g" ${qscript}_tmp > ${qscript}_tmp1
sed -e "s/UserPassword/$3/g" ${qscript}_tmp1 > ${qscript}_tmp2
mv ${qscript}_tmp2 ${qscript}_tmp
echo "executing $qscript.."
fastload -P 5 <  ${qscript}_tmp
if [ $? != 0 ]; then
        error_handle "Quick Start $qscript  job script failed."
        exit 1
fi

echo "piom Validation completed successfully."

rm -rf  ${qscript}_tmp
rm -rf ${qscript}_tmp1

cd $CURRDIR
exit 0

