/*************************************************************************
*
* Title: Paral-X Status Codes
*
* Copyright 1999-2007, by Teradata Corporation.  
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
* Description  Paral-X Status Codes
*
* Purpose
*
*
* History Information
*
* Revision    Date     DCR    DID     Comments
* ----------- -------- ------ ------- ---------------------------------------
* 13.00.00.01 10042007 115565 TSL     Copyright changes
* 12.00.00.00 09052007 xxxxxx AY2     Add PX_JumpPhase                @003
* 09.00.00.02 01152007 109869 SF3     Add PX_ErrorLimitExceeded       @002
* 09.00.00.01 06092006 105252 CFL     Dual Active Support             @001
* 05.01.00.01 02142001 100426 AY2     Support for WaitTimeout status code
* 05.00.00.01 05252005 96132  AY2     Support for TELAPI status code
* 01.00.00.02 02222000 49670  AY2     Support status text
* 01.00.00.01 11301999 00000  AY2     Initial Creation
*
*************************************************************************/
#ifndef PXSTC__H

#define PXSTC__H


typedef enum PXSTC_Code
{
  PXSTC_Success = 0,           /* 000 */
  PXSTC_BadHandle,             /* 001 */
  PXSTC_InvalidArgument,       /* 002 */
  PXSTC_NotActive,             /* 003 */
  PXSTC_Warning,               /* 004 */
  PXSTC_NotFound,              /* 005 */
  PXSTC_NotEnough,             /* 006 */
  PXSTC_UnknownError,          /* 007 */
  PXSTC_SystemError,           /* 008 */
  PXSTC_ProtocolError,         /* 009 */
  PXSTC_TimeOut,               /* 010 */
  PXSTC_EndOfProcessing,       /* 011 */
  PXSTC_EndOfData,             /* 012 */
  PXSTC_Conflict,              /* 013 */
  PXSTC_CatalogError,          /* 014 */
  PXSTC_ObjectBusy,            /* 015 */
  PXSTC_NotSupported,          /* 016 */
  PXSTC_DiscardRow,            /* 017 */
  PXSTC_NullTable,             /* 018 */
  PXSTC_Storage,               /* 019 */
  PXSTC_CountError,            /* 020 */
  PXSTC_NullPointer,           /* 021 */
  PXSTC_Size,                  /* 022 */
  PXSTC_OperatorError,         /* 023 */
  PXSTC_PathError,             /* 024 */
  PXSTC_ParserError,           /* 025 */
  PXSTC_Duplicate,             /* 026 */
  PXSTC_OpenError,             /* 027 */
  PXSTC_SyntaxError,           /* 028 */
  PXSTC_LengthError,           /* 029 */
  PXSTC_Full,                  /* 030 */
  PXSTC_CommunicationError,    /* 031 */
  PXSTC_NullHandle,            /* 032 */
  PXSTC_Checkpoint,            /* 033 */
  PXSTC_CheckpointNotReady,    /* 034 */
  PXSTC_CheckpointReady,       /* 035 */
  PXSTC_IOError,               /* 036 */
  PXSTC_MultiPhaseError,       /* 037 */
  PXSTC_NullRow,               /* 038 */
  PXSTC_InvalidDataType,       /* 039 */
  PXSTC_DataStreamError,       /* 040 */
  PXSTC_NextPhase,             /* 041 */
  PXSTC_EndMethod,             /* 042 */
  PXSTC_SamePhase,             /* 043 */
  PXSTC_SchemaError,           /* 044 */
  PXSTC_RowError,              /* 045 */
  PXSTC_MetadataError,         /* 046 */
  PXSTC_RetryError,            /* 047 */
  PXSTC_FatalError,            /* 048 */
  PXSTC_InvalidName,           /* 049 */
  PXSTC_NodeError,             /* 050 */
  PXSTC_TaskError,             /* 051 */
  PXSTC_GroupError,            /* 052 */
  PXSTC_LogCommunicationError, /* 053 */
  PXSTC_LogFileError,          /* 054 */
  PXSTC_LogPassword,           /* 055 */
  PXSTC_LogXDRError,           /* 056 */
  PXSTC_LogInsuffMemError,     /* 057 */
  PXSTC_Loghandle,             /* 058 */
  PXSTC_NoLogRec,              /* 059 */
  PXSTC_NoMessageCatalog,      /* 060 */
  PXSTC_NoRow,                 /* 061 */
  PXSTC_FlushRows,             /* 062 */
 PXSTC_InvalidTree,           /* 063 */
  PXSTC_Synchronize,           /* 064 */
  PXSTC_SynchronizeMaster,     /* 065 */
  PXSTC_SynchronizeSlave,      /* 066 */
  PXSTC_DataAcquisitionDone,   /* 067 */
  PXSTC_WaitTimeout,           /* 068 */
  PXSTC_UserRestart,           /* 069 */                           /*@001*/
  PXSTC_ErrorLimitExceeded,    /* 070 */                           /*@002*/
  PXSTC_JumpPhase,             /* 071 */                           /*@003*/
  /** Please add new status code before this line **/
  /** Also add status string at the bottom        **/
  PXSTC_MAX_
} PXSTC_Code;

#define PX_Success               PXSTC_Success                /* 000 */
#define PX_BadHandle             PXSTC_BadHandle              /* 001 */
#define PX_InvalidArgument       PXSTC_InvalidArgument        /* 002 */
#define PX_NotActive             PXSTC_NotActive              /* 003 */
#define PX_Warning               PXSTC_Warning                /* 004 */
#define PX_NotFound              PXSTC_NotFound               /* 005 */
#define PX_NotEnough             PXSTC_NotEnough              /* 006 */
#define PX_UnknownError          PXSTC_UnknownError           /* 007 */
#define PX_SystemError           PXSTC_SystemError            /* 008 */
#define PX_ProtocolError         PXSTC_ProtocolError          /* 009 */
#define PX_TimeOut               PXSTC_TimeOut                /* 010 */
#define PX_EndOfProcessing       PXSTC_EndOfProcessing        /* 011 */
#define PX_EndOfData             PXSTC_EndOfData              /* 012 */
#define PX_Conflict              PXSTC_Conflict               /* 013 */
#define PX_CatalogError          PXSTC_CatalogError           /* 014 */
#define PX_ObjectBusy            PXSTC_ObjectBusy             /* 015 */
#define PX_NotSupported          PXSTC_NotSupported           /* 016 */
#define PX_DiscardRow            PXSTC_DiscardRow             /* 017 */
#define PX_NullTable             PXSTC_NullTable              /* 018 */
#define PX_Storage               PXSTC_Storage                /* 019 */
#define PX_CountError            PXSTC_CountError             /* 020 */
#define PX_NullPointer           PXSTC_NullPointer            /* 021 */
#define PX_Size                  PXSTC_Size                   /* 022 */
#define PX_OperatorError         PXSTC_OperatorError          /* 023 */
#define PX_PathError             PXSTC_PathError              /* 024 */
#define PX_ParserError           PXSTC_ParserError            /* 025 */
#define PX_Duplicate             PXSTC_Duplicate              /* 026 */
#define PX_OpenError             PXSTC_OpenError              /* 027 */
#define PX_SyntaxError           PXSTC_SyntaxError            /* 028 */
#define PX_LengthError           PXSTC_LengthError            /* 029 */
#define PX_Full                  PXSTC_Full                   /* 030 */
#define PX_CommunicationError    PXSTC_CommunicationError     /* 031 */
#define PX_NullHandle            PXSTC_NullHandle             /* 032 */
/* #define PX_Checkpoint          PXSTC_Checkpoint      */     /* 033 */
#define PX_CheckpointNotReady    PXSTC_CheckpointNotReady     /* 034 */
#define PX_CheckpointReady       PXSTC_CheckpointReady        /* 035 */
#define PX_IOError               PXSTC_IOError                /* 036 */
#define PX_MultiPhaseError       PXSTC_MultiPhaseError        /* 037 */
#define PX_NullRow               PXSTC_NullRow                /* 038 */
#define PX_InvalidDataType       PXSTC_InvalidDataType        /* 039 */
#define PX_DataStreamError       PXSTC_DataStreamError        /* 040 */
#define PX_NextPhase             PXSTC_NextPhase              /* 041 */
#define PX_EndMethod             PXSTC_EndMethod              /* 042 */
#define PX_SamePhase             PXSTC_SamePhase              /* 043 */
#define PX_SchemaError           PXSTC_SchemaError            /* 044 */
#define PX_RowError              PXSTC_RowError               /* 045 */
#define PX_MetadataError         PXSTC_MetadataError          /* 046 */
#define PX_RetryError            PXSTC_RetryError             /* 047 */
#define PX_FatalError            PXSTC_FatalError             /* 048 */
#define PX_InvalidName           PXSTC_InvalidName            /* 049 */
#define PX_NodeError             PXSTC_NodeError              /* 050 */
#define PX_TaskError             PXSTC_TaskError              /* 051 */
#define PX_GroupError            PXSTC_GroupError             /* 052 */
#define PX_LogCommunicationError PXSTC_LogCommunicationError  /* 053 */
#define PX_LogFileError          PXSTC_LogFileError           /* 054 */
#define PX_LogPassword           PXSTC_LogPassword            /* 055 */
#define PX_LogXDRError           PXSTC_LogXDRError            /* 056 */
#define PX_LogInsuffMemError     PXSTC_LogInsuffMemError      /* 057 */
#define PX_Loghandle             PXSTC_Loghandle              /* 058 */
#define PX_NoLogRec              PXSTC_NoLogRec               /* 059 */
#define PX_NoMessageCatalog      PXSTC_NoMessageCatalog       /* 060 */
#define PX_NoRow                 PXSTC_NoRow                  /* 061 */
#define PX_FlushRows             PXSTC_Flush                  /* 062 */
#define PX_InvalidTree           PXSTC_InvalidTree            /* 063 */
#define PX_Synchronize           PXSTC_Synchronize            /* 064 */
#define PX_SynchronizeMaster     PXSTC_SynchronizeMaster      /* 065 */
#define PX_SynchronizeSlave      PXSTC_SynchronizeSlave       /* 066 */
#define PX_DataAcquisitionDone   PXSTC_DataAcquisitionDone    /* 067 */
#define PX_WaitTimeout           PXSTC_WaitTimeout            /* 068 */
#define PX_UserRestart           PXSTC_UserRestart            /* 069 *//*@001*/
#define PX_ErrorLimitExceeded    PXSTC_ErrorLimitExceeded     /* 070 *//*@002*/
#define PX_JumpPhase             PXSTC_JumpPhase              /* 071 *//*@003*/

/* DR 49670 */
#if defined(PXSTC_STRDEF)
static char PXSTC_STR[][32] =
{
  "Success",               /* 000 */
  "Bad Handle",            /* 001 */
  "Invalid Argument",      /* 002 */
  "Not Active",            /* 003 */
  "Warning",               /* 004 */
  "Not Found",             /* 005 */
  "Not Enough",            /* 006 */
  "Unknown Error",         /* 007 */
  "System Error",          /* 008 */
  "Protocol Error",        /* 009 */
  "Time Out",              /* 010 */
  "End Of Processing",     /* 011 */
  "End Of Data",           /* 012 */
  "Conflict",              /* 013 */
  "Catalog Error",         /* 014 */
  "Object Busy",           /* 015 */
  "Not Supported",         /* 016 */
  "Discard Row",           /* 017 */
  "Null Table",            /* 018 */
  "Storage",               /* 019 */
  "Count Error",           /* 020 */
  "Null Pointer",          /* 021 */
  "Size",                  /* 022 */
  "Operator Error",        /* 023 */
  "Path Error",            /* 024 */
  "Parser Error",          /* 025 */
  "Duplicate",             /* 026 */
  "Open Error",            /* 027 */
  "Syntax Error",          /* 028 */
  "Length Error",          /* 029 */
  "Full",                  /* 030 */
  "Communication Error",   /* 031 */
  "Null Handle",           /* 032 */
  "Checkpoint",            /* 033 */
  "Checkpoint Not Ready",  /* 034 */
  "Checkpoint Ready",      /* 035 */
  "IO Error",              /* 036 */
  "Multi Phase Error",     /* 037 */
  "Null Row",              /* 038 */
  "Invalid DataType",      /* 039 */
  "DataStream Error",      /* 040 */
  "Next Phase",            /* 041 */
  "End Method",            /* 042 */
  "Same Phase",            /* 043 */
  "Schema Error",          /* 044 */
  "Row Error",             /* 045 */
  "Metadata Error",        /* 046 */
  "Retry Error",           /* 047 */
  "Fatal Error",           /* 048 */
  "Invalid Name",          /* 049 */
  "Node Error",            /* 050 */
  "Task Error",            /* 051 */
  "Group Error",           /* 052 */
  "Log Communication Error", /* 053 */
  "Log File Error",        /* 054 */
  "Log Password",          /* 055 */
  "Log XDR Error",         /* 056 */
  "Log Insufficient Memory Error", /* 057 */
  "Loghandle",             /* 058 */
  "No Log Record",         /* 059 */
  "No Message Catalog",    /* 060 */
  "No Row",                /* 061 */
  "Flush Rows",            /* 062 */
  "Invalid Tree",          /* 063 */
  "Synchronize",           /* 064 */
  "SynchronizeMaster",     /* 065 */
  "SynchronizeSlave",      /* 066 */
  "DataAcquisitionDone",   /* 067 */
  "WaitTimeout",           /* 068 */
  "UserRestart",           /* 069 */                               /*@001*/
  "ErrorLimitExceeded",    /* 070 */                               /*@002*/
  "JumpPhase"              /* 070 */                               /*@003*/
};

#endif /* PXSTC_STRDEF */

#endif /* PXSTC__H */
