/*************************************************************************/
/*                                                                       */
/* File:     pxversion.h                                                 */
/*                                                                       */  
/* Purpose:  Hold the identifier of the current release of the           */
/*           Teradata Parallel Transporter product, for inclusion        */
/*           by all TPT components that need to identify the TPT         */
/*           version of their origin, for logging and/or version         */
/*           compatibility enforcement. And for holding the efix         */
/*           version for identifying efix releases of TPT.               */
/*                                                                       */
/*           ***********************************************             */   
/*           * Copyright 2005-2012 by Teradata Corporation *             */
/*           *                                             *             */
/*           * All Rights Reserved.                        *             */
/*           *                                             *             */
/*           * TERADATA CONFIDENTIAL AND TRADE SECRET      *             */
/*           ***********************************************             */
/*                                                                       */
/*  Revision     Date   D(C)R    DID             Comments                */
/* ----------- -------- ------   --- ----------------------------------- */
/* 05.00.00.01 20040624  86292   WJS Created for TWB 5.0.                */
/* 05.00.00.02 20041129  86274   WJS Added global string for efix number */
/* 05.00.00.03 20050406  93485   NT  Updated Efix Version to 001         */
/* 08.00.00.01 20050708  95475   MDV Update the version to 08.01.00.000  */
/* 08.00.00.02 20060118 100477   WJS Updated Efix Version to 001         */
/* 08.02.00.01 20060223  98401   WJS Update the version to 08.02.00.000  */
/* 08.02.00.02 20060227 101204   SS  Alpha character support             */
/* 12.00.00.01 20070112 108704   TSL Update version to 12.00.00          */
/* 13.00.00.01 20071004 115565   TSL Copyright changes                   */
/* 13.01.00.01 20081009 111278   TSL Update version to 13.01.00          */
/* 14.00.00.01 20100426 141399   WJS Update version to 14.00.00          */
/* 14.00.00.02 20110228 147718   vm185012 Give operator version          */
/* 14.10.00.01 20120216 TPT-9596 WJS Update version to 14.10.00          */
/* 16.00.00.01 20150806 TPT-25719 MDV Update version to 16.00.00         */
/* 16.00.00.02 20160907 TPT-25869 rp186055 Use CNFP build macro instead  */
/*                                         of TPT_Version string         */
/*                                                                       */
/*************************************************************************/

#ifndef PXVERSION__H                                                                  
#define PXVERSION__H 
                                                                 
/* DR101204 --> */
#define TWB_VER(p)	TWB_VER2(p)
#define TWB_VER2(p)	#p
/* <-- DR101204 */

#endif                                                                          
