/*************************************************************************
*
* Copyright 2005-2009 by Teradata Corporation.
* Copyright 2005-2010, 2014 by Teradata Corporation. 
* All Rights Reserved.
* TERADATA CONFIDENTIAL TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
*************************************************************************/

#include <stdio.h>
#include "connection.h"

class OptionsManager;

class BlockLoad
{
public:
	BlockLoad(OptionsManager * om);
	~BlockLoad(void);

	//Basic Tests
	void testLoad();
	void testUpdate();
	void testStream();

	//Utility Functions
	void setInput(char*);
	void setOutput(char*);
	void checkbuffer(char);
        int bufGetRow1MBSupport();

private:

	FILE* inputStream;
	FILE* outputStream;
	char* inputFileName;
	char* outputFileName;

	int buffersize;
	int rowheadersize;
	int rowlengthsize;
	int buftrailersize;
	int parcesize;
	int records;

	char **mbuffer;     //double buffer
	int sendbuffersize; //size of buffer to be sent
	int byteswritten;   //bytes written to current buffer
	char *curpos;       //current cursor position of buffer
	int curbuff;        //current buffer number
    OptionsManager * m_om;

};
