/*************************************************************************
*
* Copyright 2005-2010, 2014 by Teradata Corporation. 
* All Rights Reserved.
* TERADATA CONFIDENTIAL TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
*************************************************************************/

// main.cpp : Defines the entry point for the console application.

#include "BlockLoad.h"
#include "OptionsManager.h"
#include <stdio.h>
#include<string.h>

#if defined(__HIGHC__) || defined(_ATT4)
#else
using namespace std;
#endif

int main( int argc,char * argv[])
{
  OptionsManager *om = new OptionsManager();
  if (argc != 2) 
  {
    cout << "Usage:\n";
    cout << "BlockLoad <config file>\n";
    return -1;
  }
  else 
  {
    om -> readOptionsFromFile(argv[1]);
  }
  BlockLoad *dr = new BlockLoad(om);
  int oper;
		
  /***************************************************
  * Set Input/Output files
  ***************************************************/
  char *infile_name = strdup(om -> getInputFileName().c_str());
  dr -> setInput(infile_name);

  char *outfile_name = strdup(om -> getOutputFileName().c_str());
  dr -> setOutput(outfile_name);
	
  /***************************************************
  * Read in command line arguments
  ***************************************************/

  oper = om->getOperType();
  switch(oper)
  {
    case 1: dr -> testLoad();
     		break;
  //case 2: dr -> testExport();
			//break;
	case 3: dr -> testUpdate();
			break;
	case 4: dr -> testStream();
	    	break;
	default: printf("Wrong option. Run application again");
			 break;
  }

    delete om;
    delete dr;
    free(outfile_name);

#if defined(_WIN) || defined(_WIN32) || defined(_WIN64)
    printf("Press Enter to Continue\n");
    getchar();
	getchar();
#endif
    return(0);

}
