/*************************************************************************
*
* Copyright 2005-2011, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
*************************************************************************/

// main.cpp : Defines the entry point for the console application.

#include "checkpoint.h"
#include "OptionsManager.h"
#include "connection.h"
#include <stdio.h>

#if defined(__HIGHC__) || defined(_ATT4)
#else
using namespace std;
#endif

int main( int argc, char * argv[] )
{
  OptionsManager *om = new OptionsManager();
  checkpoint *dr = new checkpoint(om);

  if (argc != 2) 
  {
    cout << "Usage:\n";
    cout << "CheckPoint <config file>\n";
    return -1;
  }
  else 
  {
    om -> readOptionsFromFile(argv[1]);
  }

  /**********************************************
  * Set Input File
  **********************************************/
  char *fileName = strdup(om -> getInputFileName().c_str());
  dr -> setInput(fileName);
	
  /**********************************************
  * Run Checkpoint Test
  **********************************************/
  dr -> checkpointTest();

  delete dr;
  delete om;
  free(fileName);

#if defined(_WIN) || defined(_WIN32) || defined(_WIN64)
	printf("Press Enter to Continue\n");
	getchar();
#endif
	return(0);
}
