/*************************************************************************
*
* Copyright 2006-2011, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
*************************************************************************/

// main.cpp : Defines the entry point for the console application.

#include "GetBuffer.h"
#include "OptionsManager.h"
#include <stdio.h>
#include<string.h>

#if defined(__HIGHC__) || defined(_ATT4)
#else
using namespace std;
#endif

int main( int argc,char * argv[])
{
  OptionsManager * om = new OptionsManager();
  GenericDriver *dr = new GenericDriver(om);
  char* test_to_run = NULL;
		
  if (argc != 2) 
  {
	cout << "Usage:\n";
	cout << "GetBuffer <config file>\n";
	return -1;
  }
  else 
  {
	om -> readOptionsFromFile(argv[1]);
  }

  /***************************************************
  * Set Input/Output files
  ***************************************************/
  char *infile_name = strdup(om -> getInputFileName().c_str());
  char *outfile_name = strdup(om -> getOutputFileName().c_str());
  dr -> setInput(infile_name);
  dr -> setOutput(outfile_name);

  /***************************************************
  * Read in command line arguments
  ***************************************************/

  test_to_run = strdup(om -> getTestToRun().c_str());
  cout << endl; 

  if( !strcmp(test_to_run,"TEST_EXPORT_TO_PUTROW") )
  {
	dr -> testExportToPutRow();
  }
  else if ( !strcmp(test_to_run,"TEST_EXPORT_TO_LOAD") )
  {
	dr -> testExportToLoad();
  }
  else if ( !strcmp(test_to_run,"TEST_EXPORT_TO_UPDATE") )
  {
	dr -> testExportToUpdate();
  }
  else if ( !strcmp(test_to_run,"TEST_EXPORT_TO_STREAM") )
  {
	dr -> testExportToStream();
  }
  else if ( !strcmp(test_to_run,"TEST_EXPORT_TO_FILE") )
  {
	dr -> testExportToFile();
  }
  else
  {
	cout << "Invalid 'TEST_TO_RUN' Value: " << test_to_run << endl;
  }

  cout << endl;

  delete dr;
  delete om;
  free(infile_name);
  free(outfile_name);
  if( test_to_run != NULL )
	free(test_to_run);

#ifdef OS_WINDOWS
#if defined(_WIN) || defined(_WIN32) || defined(_WIN64)
	printf("Press Enter to Continue\n");
	getchar();
	getchar();
#endif
#endif
	return(0);

}
