/*************************************************************************
*
* Copyright 2005-2008, 2011-2012, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
*************************************************************************/

#ifndef __MULTITEST__
#define __MULTITEST__

#ifndef __MVS__
#include "synchronize.h"
#else
#include "synchron.h"
#endif //__MVS__

#include "fileio.h"
#include <fstream>
#include <stdio.h>
#include "dynlib.h"                               //DR142720

#if defined(WIN32)                                //DR142720
#include <windows.h>                              //DR142720
#endif                                            //DR142720

#include <cstdlib>        // TPT-11431

using namespace ncr::teradata::client::API;

#if defined(__HIGHC__) || defined(_ATT4)
#else
using namespace std;
#endif

class OptionsManager;

class multitest
{
 public:
  multitest(OptionsManager * om);
  ~multitest();
  int set_masterip(string);
  int set_numslaves(int);
  int set_master(bool);
  int set_inputfile(string);
  int set_outputfile(string);

  int runexport_load(int);
  int runexport_stream(int);
  int runexport_update(int);

 private:

  // For Dynamic Schema;
  void aborttest(ConnectionX *);                      //DR148806
  int api_initiate(ConnectionX *);                    //DR148806
  int api_applyrows(ConnectionX *);                   //DR148806

  int api_endacquisition(ConnectionX *);              //DR148806
  int api_terminate(ConnectionX *);                   //DR148806
  int process_returnvalue(ConnectionX *, int);        //DR148806

  synchronize mysync;      //synchronization module
  int syncerr;             //synchronization error
  string masterip;
  string inputfile;
  string outputfile;
  int numslaves;
  int rowrecv, bytesrecv;
  int rowsent, bytessent;
  bool master;
  SchemaX *schema;                                     //DR148806
  ConnectionX *conn;                                   //DR148806
  ConnectionX *connStm, *connLod, *connUpd;            //DR148806
  fileio file;
  OptionsManager *m_om;
};

#endif
