/*************************************************************************
*
* Copyright 2005-2008, 2011-2012, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
*************************************************************************/

#ifndef __SYNC__
#define __SYNC__
#ifdef HPUX
#include <iostream>
#else
#include <iostream>
#endif
#include <stdio.h>
#include <string>
#include <vector>
#include <stdlib.h>
#include <signal.h>
#include <errno.h>

//#include "mytime2.h"
#ifndef __MVS__
#include <connection.h>
#include <connectionX.h>                //DR148806
#else
#include <connecti.h>
#include <connectX.h>                   //DR148806
#endif //__MVS__

//#include <telapi_pxmdata.h>

#define NUM_SESSIONS 4
#define ROW_SIZE 100

#if defined(__MVS__)
#define _XOPEN_SOURCE_EXTENDED 1 
#endif

////UNIX definitions////
#if defined(UNIX) || defined(__MVS__)
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>     //IPv6 //TPT-10838
#include <netinet/in.h>
#include <unistd.h>
#include <sys/wait.h>
#include <arpa/inet.h>
#include <sys/time.h>
//#include <sys/times.h>
#else
#include <winsock2.h> //IPv6 //TPT-10838
#include <ws2tcpip.h> //IPv6 //TPT-10838
#endif

#define SLAVE_RUNNING -1   //status codes for slave master communication
#define SYNC_BARRIER1 0    //three different barriers to codes 
#define SYNC_BARRIER2 1 

#define SYNC_BARRIER3 2    // DR119676
#define SYNC_SCHEMA   2    // DR119676

#define SYNC_TELINFO 3
#define SYNC_CONT    4
#define SYNC_ABORT   5
#define SYNC_ERROR   -1    //error return code

#if defined(__HIGHC__) || defined(_ATT4)
#else
using namespace std;
#endif

using namespace ncr::teradata::client::API;
class synchronize
{
 public:
  synchronize();
  ~synchronize();
  int set_numslaves(int num);
  int set_masterip(string ip);
  int initialize();
  int synctelinfo(teradata::client::API::ConnectionX *conn);    //DR148806

  // DR119676 : Begin
  int syncschema(ConnectionX * );                               //DR148806

  int m_syncschema(ConnectionX *);                              //DR148806
  int s_syncschema(ConnectionX *);                              //DR148806

  // DR119676 : End
  int switchbarrier();
  int barrier(teradata::client::API::ConnectionX *conn);        //DR148806
  int terminate();
  int getid();
  char **getslavedata();
  int sendmasterdata(char*, int);
  int abort();
 private:
  int m_initialize();
  int s_initialize();
  int m_synctelinfo(teradata::client::API::ConnectionX *conn);  //DR148806
  int s_synctelinfo(teradata::client::API::ConnectionX *conn);  //DR148806
  int m_barrier();
  int s_barrier(teradata::client::API::ConnectionX *conn);      //DR148806
  int broadcast(char *, int);
  string masterip;
  bool initialized;
  bool master;
  bool telinfosync;

  // DR119676
  bool schemasync;

  bool aborted;
  int numslaves;
#if defined(UNIX) || defined(__MVS__)
  int sock;
#else
  SOCKET sock;
#endif
  struct sockaddr_in6 myaddress; //IPv6 //TPT-10838

#if !defined(UNIX) && !defined(__MVS__) 
  WORD wVersionRequested;
  WSADATA wsaData;
  int err;
#endif

  int myid;
  int numwaiting;
#if defined(UNIX) || defined(__MVS__)
  vector<int> slavesockets;         //vector for sockets of the slaves
#else
  vector<SOCKET> slavesockets;
#endif
  vector<sockaddr_in6> slaveaddress; //IPv6 //TPT-10838
  vector<int> slavestatus;          //vector to hold current slave status
  char barriercode[3];              //array of barrier codes
  int barriernum;                   //array offset of current barrier code
};

#endif



