/*************************************************************************
*
* Copyright 2005-2008, 2011, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
*************************************************************************/


#ifdef HPUX
#include <iostream>
#else
#include <iostream>
#endif

#ifndef __MVS__

  #include "multitest.h"
  #include "OptionsManager.h"

#else
 
  #include "multites.h"
  #include "OptionsM.h"

#endif//__MVS__

#ifdef UNIX
#include <sys/wait.h>
#endif

#if defined(__HIGHC__) || defined(_ATT4)
#else
using namespace std;
#endif

int main(int argc, char *argv[])
{
  char ch;

  if(argc != 4)
  {
      cout << "Required arguments\n";                     
      cout << "<master ip> <number of slaves> <config file>\n";
      return -1;
  }

  DynamicLibrary  *lib_hdl = DynamicLibrary::Instance();    //DR148806

  OptionsManager *om = new OptionsManager();
  om -> readOptionsFromFile(argv[3]);

  multitest master(om);
  master.set_numslaves(strtol(argv[2], NULL, 10));
  master.set_masterip(argv[1]);
  master.set_master(true);

  master.set_outputfile(om -> getOutputFileName());
  master.set_inputfile(om -> getInputFileName());

  int num_sessions = om -> getNumSessions();
  char *test_to_run = strdup(om -> getTestToRun().c_str());
  
  if ( !strcmp(test_to_run, "TEST_EXPORT_TO_LOAD") )
  {
    cout << "\n ************************************ ";
    cout << "\n TEST TO RUN = TEST_EXPORT_TO_LOAD " ;
    cout << "\n ************************************ "<< endl;
    master.runexport_load(num_sessions);
  }
  else 
  {
    if ( !strcmp(test_to_run, "TEST_EXPORT_TO_UPDATE") )
    {
      cout << "\n ************************************ ";
      cout << "\n TEST TO RUN = TEST_EXPORT_TO_UPDATE " ;
      cout << "\n ************************************ "<< endl;
      master.runexport_update(num_sessions);
    }
    else 
    {
      if ( !strcmp(test_to_run, "TEST_EXPORT_TO_STREAM") )
      {
        cout << "\n ************************************ ";
        cout << "\n TEST TO RUN = TEST_EXPORT_TO_STREAM " ;
        cout << "\n ************************************ "<< endl;
        master.runexport_stream(num_sessions);
      }
      else
      {
        cout << " Invalid 'TEST_TO_RUN' Value: " << test_to_run << endl;
      }
    }
  }

  cout << " Test completed\n";                             
  cout << " Press any key to continue\n";

  delete om;
  free(test_to_run);

  getchar();
  getchar();

  return 0;
}

