/**************************************************************
***********
*
* Copyright 2005-2008, 2011, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
****************************************************
*********************/


#ifdef UNIX
#include <sys/wait.h>
#endif
#ifdef HPUX
#include <iostream>
#else
#include <iostream>
#endif

#ifndef __MVS__
#include "multitest.h"
#include "OptionsManager.h"
#else
#include "multites.h"
#include "OptionsM.h"
#endif//__MVS__

#include <fstream>

#if defined(__HIGHC__) || defined(_ATT4)
#else
using namespace std;
#endif


int main(int argc, char *argv[])
{
  char ch;

  if(argc != 4)
  {
    cout << "Required arguments\n";
    cout << "<master ip> <number of slaves> <config file>\n";

    return -1;
  }

  DynamicLibrary  *lib_hdl = DynamicLibrary::Instance();     //DR148806

  OptionsManager *om = new OptionsManager();
  om -> readOptionsFromFile(argv[3]);

  multitest slave(om);
  slave.set_numslaves(strtol(argv[2], NULL, 10));
  slave.set_master(false);
  slave.set_masterip(argv[1]);

  slave.set_outputfile(om -> getOutputFileName());
  slave.set_inputfile(om -> getInputFileName());

  char *test_to_run = strdup(om -> getTestToRun().c_str());

  if ( !strcmp(test_to_run, "TEST_EXPORT_TO_LOAD") )
  {
    cout << "\n ************************************ ";
    cout << "\n TEST TO RUN = TEST_EXPORT_TO_LOAD " ;
    cout << "\n ************************************ "<< endl;
    slave.runexport_load(0);
  }
  else
  {
    if ( !strcmp(test_to_run, "TEST_EXPORT_TO_UPDATE") )
    {
      cout << "\n ************************************ ";
      cout << "\n TEST TO RUN = TEST_EXPORT_TO_UPDATE " ;
      cout << "\n ************************************ "<< endl;
      slave.runexport_update(0);
    }
    else
    {
      if ( !strcmp(test_to_run, "TEST_EXPORT_TO_STREAM") )
      {
        cout << "\n ************************************ ";
        cout << "\n TEST TO RUN = TEST_EXPORT_TO_STREAM " ;
        cout << "\n ************************************ "<< endl;
        slave.runexport_stream(0);
      }
      else
      {
        cout << " Invalid 'TEST_TO_RUN' Value: " << test_to_run << endl;
      }
    }
  }

  delete om;
  free(test_to_run);

  cout << " Test completed\n";
  cout << " Press any key to continue\n";

  getchar();
  getchar();

  return 0;
}

















