/*************************************************************************
*
* Copyright 2005-2010, 2012, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
*************************************************************************/

#ifndef __FILEIO__
#define __FILEIO__
#ifdef UNIX
#define __USEMMAP__
#endif
#include <iostream>
#include <fstream>
#include <string>
#include <stdio.h>
#ifdef __USEMMAP__
#include <unistd.h>
#include <sys/mman.h> 
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#endif

#include <cstring>        // TPT-11431

#if defined(__HIGHC__) || defined(_ATT4)
#else
using namespace std;
#endif

class fileio
{
 public:
  fileio();
  ~fileio();
  int openinput(string);
  int openoutput(string);
  int getrow(char**, unsigned short int&);
  int writerow(char *, unsigned short int);
  int closeinput();
  int closeoutput();
 private:
  int openpage(int);
  char *inputbuf;
  int buffersize;
  char end;
#ifdef __USEMMAP__
  int ifile;
#else
  FILE *ifile;
#endif
  FILE *ofile;
  int cur_page;   //input mmap status variables
  int pagesize;   //page size
  void *pageptr;  //beginning of page
  void *pageend;  //end of page
  char *curptr;   //current location in page
  long filesize;
};

#endif
