/*************************************************************************
*
* Copyright 2005-2010, 2012, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
* History Information:
*
* Revision     Date      DR      DID       Comments
* ---------------------------------------------------------------------
* 14.10.00.02  05172012  TPT-11431 vm185012  TPTAPI to add support for 
                                             gcc 4.3 Linux compiler
* 14.10.00.01  10292010  144824  mv121803  Support MVS
* 13.10.00.00  06182010  142720  mv121803  Support TELAPI dynamic loading
*
*************************************************************************/

#ifndef __MULTITEST__
#define __MULTITEST__

#ifndef __MVS__
#include "synchronize.h"
#include "fileio.h"                               //DR144824
#include "dynlib.h"                               //DR142720
#else
#include "PTCSYNCD.h"                             //DR144824
#include "PTCFILIO.h"                             //DR144824
#include "PTCDLLIB.H"                             //DR144824
#endif //__MVS__

#include <fstream>
#include <stdio.h>

#if defined(WIN32)                                //DR142720
#include <windows.h>                              //DR142720
#endif                                            //DR142720

#include <cstdlib>        // TPT-11431

using namespace teradata::client::API;


#if defined(__HIGHC__) || defined(_ATT4)
#else
using namespace std;
#endif

class OptionsManager;

class multitest
{
 public:
  multitest(OptionsManager * om);
  ~multitest();
  int set_masterip(string);
  int set_numslaves(int);
  int set_master(bool);
  int set_inputfile(string);
  int set_outputfile(string);
  int runload(int);
  int runexport(int);
  int runstream(int);
  int runupdate(int);
 private:
  void aborttest();
  int api_initiate();                                           /* DR97368 */
  int api_getrow();                                             /* DR97368 */
  int api_putrow();                                             /* DR97368 */
  int api_applyrows();                                          /* DR97368 */
  int api_endacquisition();                                     /* DR97368 */
  int api_terminate();                                          /* DR97368 */
  int process_returnvalue(int);
  synchronize mysync;      //synchronization module
  int syncerr;             //synchronization error
  string masterip;
  string inputfile;
  string outputfile;
  int numslaves;
  int rowrecv, bytesrecv;
  int rowsent, bytessent;
  bool master;
  ConnectionX *conn;       //DR142720
  fileio file;
  OptionsManager * m_om;

};

#endif
