/*************************************************************************
*
* Copyright 2010-2011, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
* History Information:
*
* Revision     Date      DR      DID       Comments
* ------------------------------------------------------------------------
* 15.00.00.00  12262013 TPT20211 kb186006  Copyright year change
* 14.00.00.01  10292010  144824  mv121803  Support MVS
* 13.00.00.01  06182010  142720  mv121803  Support TELAPI dynamic loading
*
*************************************************************************/


#ifdef HPUX
#include <iostream>
#else
#include <iostream>
#endif

#ifndef __MVS__

  #include "multitest.h"
  #include "OptionsManager.h"

#else
 
  #include "PTCMULTD.h"         //DR144824
  #include "PTCOPTMA.h"         //DR144824

#endif//__MVS__

#ifdef UNIX
#include <sys/wait.h>
#endif

#if defined(__HIGHC__) || defined(_ATT4)
#else
using namespace std;
#endif

int main(int argc, char *argv[])
{
  char ch;

  if(argc != 4)
  {
    cout << "Required arguments\n";                     
    /* DR99279 */
    cout << "<master ip> <number of slaves> <config file>\n";
    return -1;
  }

  DynamicLibrary  *lib_hdl = DynamicLibrary::Instance();    //DR142720 

  OptionsManager * om = new OptionsManager();
  om -> readOptionsFromFile(argv[3]);
  multitest master(om);
  master.set_numslaves(strtol(argv[2], NULL, 10));
  master.set_masterip(argv[1]);
  master.set_master(true);

  master.set_outputfile(om -> getOutputFileName());
  master.set_inputfile(om -> getInputFileName());

  int num_sessions;
  num_sessions = om->getNumSessions();
  int choice = 0;
  choice = om -> getOperType();

  if(choice == 2)
  {
    /* DR99279 */
    choice = om -> getNumTests();
    while(choice > 0)
	{
	  master.runexport(num_sessions);
	  choice--;
	}
  }
  else if(choice == 1)
    master.runload(num_sessions);
  else if (choice == 3)
	master.runupdate(num_sessions);
  else if(choice == 4)
	master.runstream(num_sessions);
    
  cout << "Test completed\n";                             

 /* DR99279 */
#if defined(_WIN) || defined(_WIN32) || defined(_WIN64)
  cout << "Press any key to continue\n";
  getchar();
  getchar();
#endif
  return 0;
}

