/**********************************************************************
*
* Copyright 2005-2011, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
* History Information:
*
* Revision     Date      DR      DID       Comments
* ---------------------------------------------------------------------
* 15.00.00.00  12262013 TPT20211 kb186006  Copyright year change
* 14.00.00.01  10292010  144824  mv121803  Support MVS
* 13.10.00.00  06182010  142720  mv121803  Dynamically load TELAPI
*
*************************************************************************/


#ifdef UNIX
#include <sys/wait.h>
#endif
#ifdef HPUX
#include <iostream>
#else
#include <iostream>
#endif

#ifndef __MVS__
#include "multitest.h"
#include "OptionsManager.h"
#else
#include "PTCMULTD.h"                                      //DR144824
#include "PTCOPTMA.h"                                      //DR144824
#endif//__MVS__

#include <fstream>

#if defined(__HIGHC__) || defined(_ATT4)
#else
using namespace std;
#endif


int main(int argc, char *argv[])
{
  char ch;

  if(argc != 4)
  {
    cout << "Required arguments\n";
    cout << "<master ip> <number of slaves> <config file>\n";
    return -1;
  }
  
  DynamicLibrary  *lib_hdl = DynamicLibrary::Instance();     //DR142720

  OptionsManager * om = new OptionsManager();
  om -> readOptionsFromFile(argv[3]);
  multitest slave(om);
  slave.set_numslaves(strtol(argv[2], NULL, 10));
  slave.set_master(false);
  slave.set_masterip(argv[1]);

  slave.set_outputfile(om -> getOutputFileName());
  slave.set_inputfile(om -> getInputFileName());

  int choice = 0;
  choice = om -> getOperType();

  if(choice == 2)
  {
    choice = om -> getNumTests();
    while(choice > 0)
	{
	  slave.runexport(0);
	  choice --;
	}
  }
  else if(choice == 1)
    slave.runload(0);
  else if(choice == 3)
    slave.runupdate(0);
  else if(choice == 4)
    slave.runstream(0);

  delete om;
  cout << "Test completed\n";

#if defined(_WIN) || defined(_WIN32) || defined(_WIN64)
  cout << "Press any key to continue\n";
  getchar();
  getchar();
#endif
  return 0;
}

