/*************************************************************************
*
* Copyright 2005-2008, 2010, 2012, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
*************************************************************************/

#ifndef MULTIPLE_OPERATORS_H
#define MULTIPLE_OPERATORS_H

#if defined( __MVS__) || defined(WIN32)
#else 
#define _OSUNIX_
#endif

#if defined(__MVS__)
#define OS_MVS
#elif defined(WIN32) || defined(WIN64)
#define OS_WINDOWS
#elif defined(__sun)
#define OS_SOLARIS
#elif defined(_AIX)
#define OS_AIX
#elif defined(HPUX)
#define OS_HPUX
#elif defined(__linux__)
#define OS_LINUX
#elif defined(__HIGHC__) || defined(_ATT4)
#define OS_MPRAS
#elif defined(__APPLE__)    // TPT-11370
#define OS_OSX              // TPT-11370
#else
#error Building on a unknown platform
#endif

#if defined(OS_SOLARIS) || defined(OS_AIX) || defined(OS_HPUX) || defined(OS_LINUX) || defined(OS_MPRAS) || defined(OS_OSX) // TPT-11370
#define OS_UNIX
#endif

class OptionsManager;

class MultipleOperators
{
public:
	MultipleOperators(OptionsManager * om);
	~MultipleOperators(void);

	void testExportLoad();
	void testExportStream();

private:
    OptionsManager * m_om;

};

#endif
