/*************************************************************************
*
* Copyright 2005-2008, 2010, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
*************************************************************************/

#ifndef SYNCHRONIZER_H
#define SYNCHRONIZER_H

#ifndef __MVS__                  //DR144824
  #include "common.h"
#else                            //DR144824
  #include "COMMOND.H"           //DR144824
#endif                           //DR144824

class Synchronizer {

	public:
		Synchronizer();
		~Synchronizer();

		// Routines Used by Manager
		int 	waitForThreads();
		void	awakenThreads(int);

		// Routines Used by Worker Threads
		void	waitForManager(int);
		void	signalManager(int,int);
		int	writeOutRow(FILE*,char*,TD_Length);

	private:

		/**********************************************
                * Thread Synchronization variables used for
                * worker threads to signal manager of an incoming
                * message.
                **********************************************/
                pthread_cond_t msgCond;
                pthread_mutex_t msgMutex;
                //PerfTestMessage* managerMsgBox;
		list<int> managerMsgBox;
                int managerWaiting;
                
                /**********************************************
                * Thread synchronization variables used to
                * implement barrier points.
                **********************************************/
                pthread_cond_t syncCond[2];   
                pthread_mutex_t syncMutex[2];
                int signalStatus[2];

                /**********************************************
                * Export file synchronization variables
                **********************************************/
		pthread_mutex_t exportMutex;
	
};




#endif
