/*************************************************************************
*
* Copyright 2005-2008, 2010, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
*************************************************************************/

#ifndef THREADTEST_H
#define THREADTEST_H

#ifndef __MVS__
#include "common.h"
#include "ThreadTestParameters.h"
#include "Synchronizer.h"
#include "TestBase.h"
#else
#include "COMMOND.H"              //DR144824
#include "PTCTHTPD.h"             //DR144824
#include "PTCTSYND.h"             //DR144824
#include "PTCBASTD.h"             //DR144824
#endif //__MVS__

//extern DWORD WINAPI ThreadTestLoad   (LPVOID lpParameter);
//extern DWORD WINAPI ThreadTestStream (LPVOID lpParameter);

class ThreadTest {

	public:

		ThreadTest(ThreadTestParameters*);
		~ThreadTest();

		int serviceThreads();
		int waitForThreads();
		int runLoad();
		int runUpdate();
		int runStream();
		int runExport();
		int runSim();

		void processBarrier(int mBarrier, int sBarrier, int cMethod);
		int syncTELINFO();
		int awakenThreads();
		int broadcast(int status);

	private:

		int mActiveHandle;

		int mRunStatus;

		ThreadTestParameters* mParams;

		Synchronizer* mSync;

		vector<TestBase*> tBases;
		vector<pthread_t> hthread;
		
		FILE* errorLog;
};


#endif
