/*************************************************************************
*
* Copyright 2010, 2013-2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
* History Information:
*
* Revision     Date      DR      DID       Comments
* ---------------------------------------------------------------------
* 15.00.00.00  12262013 TPT20211 kb186006  Copyright year change
* 13.00.00.00  06182010  142720  mv121803  Dynamically load TELAPI
*
*************************************************************************/

#ifndef THREADTESTPARAMETERS_H
#define THREADTESTPARAMETERS_H

#ifndef __MVS__              //DR144824
  #include "common.h"
#else                        //DR144824
  #include "COMMOND.H"       //DR144824
#endif                       //DR144824

class ThreadTestParameters {

	public:

		ThreadTestParameters(TD_OperatorType oper, int numInstances);
		~ThreadTestParameters();

		void	AddAttribute(TD_Attribute,int,const char*,...);  //TPT-17718

		void	SetLogon(char* userName, char* userpwd, char* tdpid);
		void	SetFile(char* name);
		void	SetTable(int tableCount, char* tableName,...);
		void	SetSessions(int max, int min);
		void	SetCheckpoint(int checkPointInterval, int restartAttempts );
		void    SetTracing(TD_TraceLevel level);
		void	SetFail(int instance, int rowCount);
		void	SetRowLimit(int instance, int rowCount);
		void	SetBufferMode(int enable, int rowsPerBuffer);
		
	public:

		vector<TD_Attribute>	mAttributeTypes;
		vector<char*>		mAttributeValues;
		vector<int>		mAttributeValueCount;
		vector<SchemaX*>	mSchemaList;            //DR142720
		vector<DMLGroupX*>	mDMLGroupList;          //DR142720
		vector<int>		mInstanceFail;
		vector<int>		mRowCountFail;
		vector<int>		mDidFail;
		vector<int>		mInstanceLimit;
		vector<int>		mRowCountLimit;

		char*			mSourceFileName;
		size_t			mRowSize;
		int			mNumThreads;

		int			mCheckpointInterval;
		int			mRestartAttempts;
		int			mCreateNewConnection;
		int			mBufferModeEnabled;
		int			mBufferRowCountLimit;

		TD_OperatorType		mOperType;
		TD_TraceLevel           mTraceLevel;

};

#endif
