/*************************************************************************
*
* Copyright 2005-2010, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
*************************************************************************/

// main.cpp : Defines the entry point for the console application.

#ifndef __MVS__

  #include "eventLog.h"
  #include "OptionsManager.h"
  #include <stdio.h>
  #include<string.h>

#else

  #include "GenericD.h"
  #include "OptionsM.h"
  #include <stdio.h>
  #include <string.h>

#endif//__MVS__

#if defined(__HIGHC__) || defined(_ATT4)
#else
using namespace std;
#endif

int main( int argc, char *argv[] )
{
   OptionsManager *om = new OptionsManager();
   eventLog *dr = new eventLog(om);
   int oper;

   if (argc != 2) 
   {
       cout << "Usage:\n";
       cout << "eventLog <config file>\n";
       return -1;
   }
   else 
   {
       om -> readOptionsFromFile(argv[1]);
   }

   /***************************************************
   * Set Input/Output files
   ***************************************************/
   char *infile_name  = strdup(om -> getInputFileName().c_str());
   char *outfile_name = strdup(om -> getOutputFileName().c_str());

   dr -> setInput(infile_name);
   dr -> setOutput(outfile_name);
	
   ///***************************************************
   //* Read in command line arguments
   //***************************************************/

    oper = om -> getOperType();
    switch(oper)
    {
      case 1 : dr -> testLoad();
               break;

      case 2 : dr -> testExport();
               break;

      case 3 : dr -> testUpdate();
               break;

      case 4 : dr -> testExportToStream();
               break;

      default: printf("Wrong option. Run application again");
               break;
    }

    delete dr;
    delete om;

    free(infile_name);
    free(outfile_name);

    return(0);
}


