/*************************************************************************
*
* Copyright 2005-2012, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
*************************************************************************/

#ifndef __MULTITEST__
#define __MULTITEST__

#ifndef __MVS__
#include "synchronize.h"
#include "fileio.h"
#else
#include "PTCSYNCR.h"
#include "PTCFILIO.h"
#endif //__MVS__

#include <fstream>
#include <stdio.h>

#include <cstdlib>       // TPT-11431

using namespace teradata::client::API;

#if defined(__HIGHC__) || defined(_ATT4)
#else
using namespace std;
#endif

class OptionsManager;

class multitest
{
 public:
  multitest(OptionsManager * om);
  ~multitest();
  int set_masterip(string);
  int set_numslaves(int);
  int set_master(bool);
  int set_inputfile(string);
  int set_outputfile(string);
  int runload(int);
  int runexport(int);
  int runstream(int);
  int runupdate(int);
 private:
  void aborttest();
  int api_initiate();                                           /* DR97368 */
  int api_getrow();                                             /* DR97368 */
  int api_putrow();                                             /* DR97368 */
  int api_applyrows();                                          /* DR97368 */
  int api_endacquisition();                                     /* DR97368 */
  int api_terminate();                                          /* DR97368 */
  int process_returnvalue(int);
  synchronize mysync;      //synchronization module
  int syncerr;             //synchronization error
  string masterip;
  string inputfile;
  string outputfile;
  int numslaves;
  int rowrecv, bytesrecv;
  int rowsent, bytessent;
  bool master;
  Connection *conn;
  fileio file;
  OptionsManager * m_om;
};

#endif
