/*************************************************************************
*
* Copyright 2005-2011, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
*************************************************************************/


#ifdef HPUX
  #include <iostream>
#else
  #include <iostream>
#endif

#ifndef __MVS__
  #include "multitest.h"
  #include "OptionsManager.h"
#else
  #include "PTCMULTI.h"
  #include "PTCOPTMA.h"
#endif

#ifdef UNIX
  #include <sys/wait.h>
#endif

#if defined(__HIGHC__) || defined(_ATT4)
#else
  using namespace std;
#endif

int main(int argc, char *argv[])
{
  char ch;
  if(argc != 4)
  {
    cout << "Required arguments\n";                     
    /* DR99279 */
    cout << "<master ip> <number of slaves> <config file>\n";
    return -1;
  }

  OptionsManager * om = new OptionsManager();
  om -> readOptionsFromFile(argv[3]);
  multitest master(om);
  master.set_numslaves(strtol(argv[2], NULL, 10));
  master.set_masterip(argv[1]);
  master.set_master(true);

  master.set_outputfile(om -> getOutputFileName());
  master.set_inputfile(om -> getInputFileName());

  int num_sessions;
  num_sessions = om -> getNumSessions();
  int choice = 0;
  choice = om -> getOperType();
  if(choice == 2)
  {
    choice = om -> getNumTests();
    while(choice > 0)
	{
	  master.runexport(num_sessions);
	  choice--;
	}
  }
  else if(choice == 1)
    master.runload(num_sessions);
  else if (choice == 3)
	master.runupdate(num_sessions);
  else if(choice == 4)
	master.runstream(num_sessions);
    
  cout << "Test completed\n";                             
 /* DR99279 */

#if defined(_WIN) || defined(_WIN32) || defined(_WIN64)
  cout << "Press any key to continue\n";
  getchar();
  getchar();
#endif
  return 0;
}

