/**************************************************************
*
* Copyright 2005-2011, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
****************************************************/

#ifdef UNIX
#include <sys/wait.h>
#endif
#ifdef HPUX
#include <iostream>
#else
#include <iostream>
#endif

#ifndef __MVS__
#include "multitest.h"
#include "OptionsManager.h"
#else
#include "PTCMULTI.h"
#include "PTCOPTMA.h"
#endif

#include <fstream>

#if defined(__HIGHC__) || defined(_ATT4)
#else
using namespace std;
#endif


int main(int argc, char *argv[])
{
  char ch;
  if(argc != 4)
  {
    cout << "Required arguments\n";
    cout << "<master ip> <number of slaves> <config file>\n";
    return -1;
  }

  OptionsManager * om = new OptionsManager();
  om -> readOptionsFromFile(argv[3]);
  multitest slave(om);
  slave.set_numslaves(strtol(argv[2], NULL, 10));
  slave.set_master(false);
  slave.set_masterip(argv[1]);

  slave.set_outputfile(om -> getOutputFileName());
  slave.set_inputfile(om -> getInputFileName());

  int choice = 0;
  choice = om -> getOperType();
  if(choice == 2)
  {
    /* DR99279 */
    choice = om -> getNumTests();
    while(choice > 0)
    {
	  slave.runexport(0);
	  choice --;
	}
  }
  else if(choice == 1)
    slave.runload(0);
  else if(choice == 3)
    slave.runupdate(0);
  else if(choice == 4)
    slave.runstream(0);

  delete om;
  cout << "Test completed\n";

#if defined(_WIN) || defined(_WIN32) || defined(_WIN64)
  cout << "Press any key to continue\n";
  getchar();
  getchar();
#endif

  return 0;
}

















