/*******************************************
*
* Copyright 2006-2009, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
* Description:
*
* Header file for GenericDriver
*
*/

#ifndef GENERICDRIVER_H
#define GENERICDRIVER_H

#ifndef __BUILD_APP
#define SQL_TEXT Latin_Text
#include <sqltypes_td.h>
#else
#define LOB_RESULT_LOCATOR int
#define SQL_TEXT unsigned char
#endif

#include <stdio.h>
#include "OptionsReader.h"
#include "connection.h"

typedef struct {
   int MaxMsgSize;
   int RowHeaderSize;
   int RowLengthSize;
   int BufTrailerSize;
} BufferLayout;

class GenericDriver
{
public:
	GenericDriver(OptionsReader *);
	GenericDriver(OptionsReader *, OptionsReader *);
	~GenericDriver();

	void testLoad(char *, SQL_TEXT *);
	void testExport(char *, SQL_TEXT *);
	void testUpdate(char *, SQL_TEXT *);
	void testStream(char *, SQL_TEXT *);
	void testExport2Load(char *, SQL_TEXT *, VARCHAR_LATIN *);
	void testExport2Update(char *, SQL_TEXT *, VARCHAR_LATIN *);
	void testExport2Stream(char *, SQL_TEXT *, VARCHAR_LATIN *);

	void setInput(char *);
	void setOutput(char*);
	int GetRowData(char * , size_t);
	int WriteRowData(char * , TD_Length);

private:
	OptionsReader *m_om;
	OptionsReader *m_omload;
	char *inputFileName;
	char* outputFileName;
	LOB_RESULT_LOCATOR *outputLob;
	FILE *inputStream;
	FILE* outputStream;
};

#endif
