/*******************************************
*
* Copyright 2006-2009, 2014 by Teradata Corporation.
* All Rights Reserved.
* TERADATA CONFIDENTIAL AND TRADE SECRET
*
* This copyrighted material is the Confidential, Unpublished
* Property of the Teradata Corporation.  This copyright notice and
* any other copyright notices included in machine readable
* copies must be reproduced on all authorized copies.
*
* Description:
*
* Header file for OptionsReader
*
*/

#ifndef OPTIONSREADER_H
#define OPTIONSREADER_H

#include "connection.h"

#define SAM_DML_STATEMENT "DML_STATEMENT"
#define SAM_COLUMN "COLUMN"
#define SAM_ROW_LENGTH "ROW_LENGTH"
#define SAM_SERIALIZE_ON "SERIALIZE_ON"
#define SAM_USE_LIST "USE_LIST"

#define SAM_SYSTEM_OPERATOR "TD_SYSTEM_OPERATOR"
#define SAM_STREAM "TD_STREAM"

#define SAM_NONE "TD_NONE"
#define SAM_INTEGER "TD_INTEGER"
#define SAM_SMALLINT "TD_SMALLINT"
#define SAM_FLOAT "TD_FLOAT"
#define SAM_DECIMAL "TD_DECIMAL"
#define SAM_CHAR "TD_CHAR"
#define SAM_BYTEINT "TD_BYTEINT"
#define SAM_VARCHAR "TD_VARCHAR"
#define SAM_LONGVARCHAR "TD_LONGVARCHAR"
#define SAM_BYTE "TD_BYTE"
#define SAM_VARBYTE "TD_VARBYTE"
#define SAM_DATE "TD_DATE"
#define SAM_GRAPHIC "TD_GRAPHIC"
#define SAM_VARGRAPHIC "TD_VARGRAPHIC"
#define SAM_LONGVARGRAPHIC "TD_LONGVARGRAPHIC"
#define SAM_DATE_ANSI "TD_DATE_ANSI"
#define SAM_BIGINT "TD_BIGINT"

#define SAM_USER_NAME "TD_USER_NAME"
#define SAM_USER_PASSWORD "TD_USER_PASSWORD"
#define SAM_TDP_ID "TD_TDP_ID"
#define SAM_TARGET_TABLE "TD_TARGET_TABLE"
#define SAM_TARGET_TABLE_ARRAY "TD_TARGET_TABLE_ARRAY"
#define SAM_LOG_TABLE "TD_LOG_TABLE"
#define SAM_MIN_SESSIONS "TD_MIN_SESSIONS"
#define SAM_MAX_SESSIONS "TD_MAX_SESSIONS"
#define SAM_SELECT_STMT "TD_SELECT_STMT"
#define SAM_ERROR_TABLE "TD_ERROR_TABLE"
#define SAM_ERROR_TABLE_1_ARRAY "TD_ERROR_TABLE_1_ARRAY"
#define SAM_ERROR_TABLE_2_ARRAY "TD_ERROR_TABLE_2_ARRAY"
#define SAM_WORK_TABLE_ARRAY "TD_WORK_TABLE_ARRAY"
#define SAM_TENACITY_HOURS "TD_TENACITY_HOURS"
#define SAM_TENACITY_SLEEP "TD_TENACITY_SLEEP"
#define SAM_ROBUST "TD_ROBUST"

using namespace teradata::client::API;

class OptionsReader {
private:
	char *m_optionsFileName;
	int row_length;
public:
	int getRowLength();
	int readOptionsFromFile(Connection * , 
		Schema * , 
		DMLGroup * ,
		char * ,
                unsigned char * ,
		unsigned char * = NULL);
	OptionsReader(const char *);
	virtual ~OptionsReader();
	static TD_DataType parseDataType(const char *);
};

#endif


